<?php

namespace App\Http\Libraries\firebase;

use App\Http\Libraries\firebase\FCMPushNotification;
use App\Http\Utility\Constant;
use Validator;


Class FCMPushNotificationServiceProvider
{

    //set Notification title

    public function setTitle($title)
    {
        $this->title = $title;
    }



    public function sendPushNotification($arg)
    {

        $serverApiKey   = "AAAAkiq_cbM:APA91bHjGKWZ2M5FBa-dG6ssIhdUCCCy1Lo0Afi5_UrKmD6jd1oWAsh1u6GHNVOcI5Ps7MWpyP8unG16uEEGM4lN_pkTOjKeIEIvo9yZu9VpJTiYBKZ3jYrOU9mkA3K-b1nLvydDaEIn";
        $deviceToken    = $arg['deviceToken'];
        //$os             = $arg['os'];
        $os             = 'android';
        $notificationContent = ('ios' === strtolower($os)) ? $this->buildIosNotification($arg) : $this->buildAndroidNotification($arg);
        $gcpm = new FCMPushNotification();
        $gcpm->setDeviceId($deviceToken);
        $gcpm->setServerApiKey($serverApiKey);
        $gcpm->setNotificationContent($notificationContent);
        $result = $gcpm->send();

        return $result;
    }

    //androidNotification
    public function buildAndroidNotification($data)
    {

        $fields = [
                   'registration_ids'  => [$data['deviceToken']],
                   'sound'		       => 'default',
                   'vibrate'	       => 'default',
                   // 'data'              => [
                   //                          "message"   => $data['message'],
                   //                          "image"     => $data['body']['image'],
                   //                          "title"     => $this->title,
                   //                          "notification_type"=>$data['body']['notification_type'],
                   //                           $data['body']['extraKey'] =>$data['body']['extraValue']
                   //                       ],
                   'data'              => [
                                            "message"   => $data['message'],
                                            // "image"     => $data['body']['image'],
                                            "title"     => $this->title,
                                            "notification_type"=>$data['body'],
                                             // $data['body']['extraKey'] =>$data['body']['extraValue']
                                         ],                   
                  ];
        return $fields;
    }

    public function buildIosNotification($data)
    {

        // $msgbody =[
        //             "notification_type"             =>$data['body']['notification_type'],
        //             $data['body']['extraKey']       =>$data['body']['extraValue']
        //           ];   
        $msg = array();  
        $msg['sound']   = 'default';
        $msg['icon']    = '@drawable/icon';
        $msg['title']   = $this->title;
        $msg['body']    = $data['body'];    
        $fields         = [
                            'registration_ids'  => [$data['deviceToken']],
                            'data'              => [
                                                    "message" => $data['message'],
                                                    "image"   => "false"],
                            'content_available' => true,
                            'priority'          => 'high',
                            'badge'             => 1,
                            'sound'             => 'default',
                            'notification'      => $msg
                            ];

        return $fields;
    }






}