<?php



namespace App\Http\Controllers\admin;



use Illuminate\Http\Request;

use App\Http\Controllers\Controller;

use App\Adminlogin;

use DB;

use Illuminate\Support\Facades\Crypt;

use Illuminate\Contracts\Encryption\DecryptException;

use App\Clubs;

use App\Events;
use App\NewsModel;
use App\Users;
use App\Managers;
use App\Gallery;
use App\Event_attendance;
use App\Setting;
use App\Info;
use App\Pushnotification;

use Validator;

use Intervention\Image\ImageManagerStatic as Image;

use App\Http\Requests\ClubValidation;

use App\Http\Requests\EventValidation;
use App\Http\Requests\EditEventValidation;
use App\Http\Requests\AddEventValidation;
use App\Http\Libraries\firebase\PushMessageCustom;

class AdminController extends Controller

{

  public function __construct()

  {

    DB::enableQueryLog();

  }

  public function CommonAed(Request $request,$userId,$status,$callback,$tablename)

  {

         try {

          //echo $tablename;die;

            $id = Crypt::decryptString($userId);

            $status = Crypt::decryptString($status);

            $tablename = Crypt::decryptString($tablename);

         } catch (DecryptException $e) {

            $message = trans('messages.invalid_info');

            $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");

            return redirect('admin/dashboard');

         }

         if($status != 0 && $status != 1 && $status != 2 && $status != 3)

         {

            $message = trans('messages.invalid_info');

            $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");

            return redirect("admin/".$callback);

         } 



         #echo $tablename;die;

         $result = DB::table($tablename)->where("id",$id)->count();

         

         if($result)

         {



            $update_array = array("status" => $status);

            $response = DB::table($tablename)->where("id",$id)->update($update_array);

            if($response == 1)

            {

               if($tablename == 'Users')

               {

                  /*$user_obj = new Users();

                  $userInfo = $user_obj->select('loginType','userName','email')->where('id',$id)->first();

                  $userType = $userInfo['loginType'];*/

                  

                   

                     /*$mailMsg = '';$mailSubject = '';

                     if($status == 1){ //Approve

                        $mailMsg = trans('messages.Your account has been unarroved');

                        $mailSubject = trans('messages.Account Unapproved');

                     }elseif($status == 2){  //Unapprove

                        $mailMsg = trans('messages.Your account has been arroved');

                        $mailSubject = trans('messages.Account Approved');   

                     }



                      

                     $objDemo = new \stdClass();

                     $objDemo->invoice_file = '';

                     $objDemo->sender = 'SwissExpress';

                     $objDemo->receiver = $userInfo['userName'];

                     $objDemo->from = env( 'MAIL_USERNAME' );

                     $objDemo->subject = $mailSubject;

                     $objDemo->message = $mailMsg;

                     $objDemo->view_file = 'emailtemplate.company_account_status';

                     Mail::to($userInfo['email'])->send(new DemoEmail($objDemo)); */

                       

                  

               }



               if($tablename == 'drivers'){

                  /*$driver_obj = new Drivers();

                  $driverInfo = $driver_obj->select('fullname','email')->where('id',$id)->first();*/

                  

                  /*$mailMsg = '';$mailSubject = '';

                  if($status == 1){ //Approve

                     $mailMsg = trans('messages.Your account has been unarroved');

                     $mailSubject = trans('messages.Account Unapproved');

                  }elseif($status == 2){  //Unapprove

                     $mailMsg = trans('messages.Your account has been arroved');

                     $mailSubject = trans('messages.Account Approved');   

                  }



                   

                  $objDemo = new \stdClass();

                  $objDemo->invoice_file = '';

                  $objDemo->sender = 'SwissExpress';

                  $objDemo->receiver = $driverInfo['fullname'];

                  $objDemo->from = env( 'MAIL_USERNAME' );

                  $objDemo->subject = $mailSubject;

                  $objDemo->message = $mailMsg;

                  $objDemo->view_file = 'emailtemplate.company_account_status';

                  Mail::to($driverInfo['email'])->send(new DemoEmail($objDemo));*/ 

                    

                  

               }



               $messages = trans('messages.Record updated successfully');

               $request->session()->flash("message","<div class='alert alert-success'><strong>".$messages.".</strong></div>");

            }else{

               $messages = trans('messages.went_wrong');

               $request->session()->flash("message","<div class='alert alert-danger'><strong>".$messages."</strong></div>");

          }

         }else{

            $messages = trans('messages.This record is not exist');

            $request->session()->flash("message","<div class='alert alert-danger'><strong>".$messages.".</strong></div>");

         }  

         return redirect("admin/".$callback);      

   }

    public function login(Request $request)

    {

  		$data['heading'] = trans('messages.Admin Login');

 			return view("admin.login")->with(array("data"=> $data));

    }

    public function LoginSubmit(Request $request){

   	$messages = [

         'username.required' => trans('validation.required'),

         'password.required' => trans('validation.required')

     	];

      $validatedData = $request->validate([

            'username' => 'required',

            'password' => 'required'

     	],$messages);



   	$admin_obj = new Adminlogin();

    	$result = $admin_obj->where("username" , $request->username)

    				->where("password" , md5($request->password))->first();



      $query = DB::getQueryLog();

      

      if(!empty($result))

     	{

     		session(["id" => $result->id,"login_type"=>"Admin"]);

    		$message =  trans('messages.login_successfully');

    		$request->session()->flash("message","<div class='alert alert-success'><strong>".$message.".</strong></div>");

        	return redirect("admin/getGallery");

		}else{

        	$message =  trans('messages.email_pass_not_match');

        	$request->session()->flash("message","<div class='alert  alert-danger'><strong>".$message.".</strong></div>");

        	return redirect("login")->withInput();

     	}  

   }

   public function dashboard(Request $request)

   {

   		$data['heading'] = trans('messages.Admin Dashboard');

      	return view("admin.dashboard")->with(array("data"=> $data));

   }

   public function addclubSubmit(ClubValidation $request)

   {

      #echo "<pre>";print_r($request->all());

      $Clubs_obj = new Clubs();

      $all_var = $request->all();

      $all_var["status"] = 1;

      $response = $Clubs_obj->insert_record($all_var);

      if($response == 1)

      {

        $message =  trans('messages.Club added successfully');

        $request->session()->flash("message","<div class='alert alert-success'><strong>".$message."</strong></div>");

      }else{

        $message =  trans('messages.went_wrong');

        $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");

      }

      return redirect("admin/listClub");

   }

   public function editClubSubmit(ClubValidation $request)

   {

      $Clubs_obj = new Clubs();

      $all_var = $request->all();

      $response = $Clubs_obj->update_record($all_var);

      if($response == 1)

      {

        $message =  trans('messages.Record updated successfully');

        $request->session()->flash("message","<div class='alert alert-success'><strong>".$message."</strong></div>");

      }else{

        $message =  trans('messages.went_wrong');

        $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");

      }

      return redirect("admin/listClub");

   }

   public function addEventSubmit(AddEventValidation $request)
   {
    //AddEventValidation
    #echo $_FILES["image"]["size"][0]."<pre>";print_r($_FILES);die;
      if($_FILES["image"]["size"][0] > 0)
      {
          #echo "hello";die;
          $image_error = 0;
          for ($i=0; $i <count($_FILES["image"]["name"]); $i++)
          {
              $ext_var = $_FILES["image"]["name"][$i];
              $explode_var = explode(".",$ext_var);
              $extension = strtolower($explode_var[1]);
              if($extension == "jpg" || $extension == "jpeg" || $extension == "gif" || $extension == "png" || $extension == "tif")
              {
                  $image_error = 0;
              }else{
                  $image_error = 1;
              }
          }
          if($image_error == 1)
          {
            $message = trans('messages.image_type_error');
            $message =  trans('messages.went_wrong');
            $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
            return redirect("addEvent");
          }else{
              $file_name = array();
              for ($i=0; $i <count($_FILES["image"]["name"]); $i++)
              {
                  $ext_var = $_FILES["image"]["name"][$i];
                  $image = $request->file('image');
                  $explode_var = explode(".",$ext_var);
                  $extension = strtolower($explode_var[1]);
                  $image = $_FILES["image"]["name"][$i];
                  $random = substr(md5(mt_rand()), 0, 4);
                  $file_name[] = $input['imagename'] = time().$random.'.'.$extension;
                  #echo 
                  $destinationPath = public_path('/upload/events');
                  //$image->move($destinationPath, $input['imagename']);
                  move_uploaded_file($_FILES["image"]["tmp_name"][$i], $destinationPath."/".$input['imagename']);
              }

              #echo "<pre>";print_r($file_name);die;

              for ($y=0; $y <count($file_name) ; $y++)

              { 

                #echo $file_name[$y];
                #echo public_path('/upload/events'.'/'.$file_name[$y]);die;

                $img = Image::make(public_path('/upload/events'.'/'.$file_name[$y]));
                #echo "<pre>";print_r($img);die;
                $img->insert(public_path('download.jpg'), 'bottom-right', 10, 10);

                $img->save(public_path('/upload/events'.'/'.$file_name[$y])); 

              }

              $image = implode(",", $file_name);

              //echo $input['imagename']."form submit";
              #error_reporting(E_ALL);

             # echo $image."<pre>";print_r($file_name);die;

          }

        }else{

          $message = trans('messages.Image is required');

            $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");

            return redirect("admin/addEvent");

        }
        $s_d = date("Y-m-d",strtotime($request->start_date));
        $s_t = date("H:i:s",strtotime($request->end_time));
        $insert_array = array(

          "club_id" => $request->club_id,
          "price" => $request->price,

          "event_name" => $request->event_name,

          "start_date" => date("Y-m-d",strtotime($request->start_date)),

          "start_time" => $request->start_time,

          "end_time" => $request->end_time,
          "start_date_time" => $s_d." ".$s_t,
          "description" => $request->description,

          "image" => $image,
          "points" => 0,

        );

        $Events_obj = new Events($insert_array);

        $response = $Events_obj->save();

        if($response == 1)

        {

          $message =  trans('messages.Event created successfully');

          $request->session()->flash("message","<div class='alert alert-success'><strong>".$message."</strong></div>");

        }else{

          $message =  trans('messages.went_wrong');

          $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");

        }

        return redirect("admin/listEvent");

   }

   public function addWatermark($value = "image.jpg")

   {

      $img = Image::make(public_path($value)); //your image I assume you have in public directory

      $img->insert(public_path('download.jpg'), 'bottom-right', 10, 10); //insert watermark in (also from public_directory)

      $img->save(public_path($value)); //save created image (will override old image)

   }

   public function listEvent(Request $request)

   {

      $Events_obj = new Events();

      $Clubs = new Clubs();
        $data["record_club"] = $Clubs->get_record_all_active();

      $query = $Events_obj->select("events.*","clubs.club_name")
                  ->join("clubs","events.club_id","clubs.id")
                  ->orderBy("events.id","desc");

            if($request->has('searchsubmit') && !empty($request->club_id))
            {
              $query->where('clubs.id',$request->club_id);
            }
            if($request->has('searchsubmit') && !empty($request->event_name))
            {
              $query->where('events.event_name','like','%'.$request->event_name.'%');
            }
            if($request->has('searchsubmit') && !empty($request->from_date)&& !empty($request->to_date))
            {
                $from_date = $request->from_date;
                $to_date = $request->to_date;
                
                //$from_date = date('Y-m-d', strtotime(str_replace('/', '-', $request->from_date)));
                //echo $from_date;
                #echo $to_date;
                //die;

                //$to_date = date("Y-m-d",strtotime($to_date));
                
                $ar = array($from_date,$to_date);
                $query->whereBetween('events.start_date',$ar);
            }
        $data["record"] = $query->paginate(10);
        /*$gett = DB::getQueryLog();
        echo "<pre>";print_r($gett);*/
      $data["heading"] = trans("messages.listEvent");

      return view("admin/listEvent")->with(array("data"=>$data));

   }

   public function editEvents(Request $request , $id)

   {

      $Clubs = new Clubs();

      $data["club_record"] = $Clubs->get_record_all();

      $id = Crypt::decryptString($id);

      $Events_obj = new Events();

      $data["record"] = $Events_obj->select("*")->where("id",$id)->first();

      $data["heading"] = trans("messages.editEvent");

      return view("admin/editEvents")->with(array("data"=>$data));

   }

   public function editEventSubmit(EditEventValidation $request)

   {

    $s_d = date("Y-m-d",strtotime($request->start_date));
        $s_t = date("H:i:s",strtotime($request->end_time));
      $update_array = array(

          "price" => $request->price,
          "club_id" => $request->club_id,

          "event_name" => $request->event_name,

          "start_date" => date("Y-m-d",strtotime($request->start_date)),

          "start_time" => $request->start_time,

          "end_time" => $request->end_time,
          "start_date_time" => $s_d." ".$s_t,

          "description" => $request->description,
          #"points" => $request->point,

        );

        $Events_obj = new Events();

        $response = $Events_obj->where("id",$request->id)->update($update_array);

        if($response == 1)

        {

          $message =  trans('messages.Record updated successfully');

          $request->session()->flash("message","<div class='alert alert-success'><strong>".$message."</strong></div>");

        }else{

          $message =  trans('messages.went_wrong');

          $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");

        }

        return redirect("admin/listEvent");

   }

   public function addNewsSubmit(Request $request)
   {
      $validatedData = $request->validate([
         'title' => 'required',
         'detail'   => 'required',
      ]);

      $insert_array = array("title" => $request->title,"text" => $request->detail);
      $newsObj = new NewsModel();
      $response = $newsObj->insert_record($insert_array);
      if($response == 1)
      {
         $message =  trans('messages.News created successfully');
         $request->session()->flash("message","<div class='alert alert-success'><strong>".$message."</strong></div>");
      }else{
         $message =  trans('messages.went_wrong');
         $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
      }
      return redirect("admin/listNews");
   }

   public function editNewsSubmit(Request $request)
   {
      $validatedData = $request->validate([
         'title' => 'required',
         'detail'   => 'required',
      ]);

      try{
         $id = Crypt::decryptString($request->i);
         $where = array('id' => $id);
         $newsObj = new NewsModel();
         $isExist = $newsObj->getCount($where);
         if($isExist){
            $update_array = array("title" => $request->title,"text" => $request->detail);
            $response = $newsObj->update_record($where,$update_array);
            if($response == 1)
            {
               $message =  trans('messages.News updated successfully');
               $request->session()->flash("message","<div class='alert alert-success'><strong>".$message."</strong></div>");
            }else{
               $message =  trans('messages.went_wrong');
               $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
            }
         }else{
            $message =  trans('messages.went_wrong');
            $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
         }
      }catch(DecryptException $e){
         $message = trans('messages.invalid_info');
         $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
      }
      return redirect("admin/listNews");
   }

   public function delNews(Request $request,$id){
      $newsObj = new NewsModel();
      try{
         $id = Crypt::decryptString($id);
         $where = array('id' => $id);
         $newsObj = new NewsModel();
         $isExist = $newsObj->getCount($where);
         if($isExist){
            $newsObj->del_record($where);
            $message =  trans('messages.News deleted successfully');
            $request->session()->flash("message","<div class='alert alert-success'><strong>".$message."</strong></div>");
         }else{
            $message =  trans('messages.went_wrong');
            $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
         }
      }catch(DecryptException $e){
         $message = trans('messages.invalid_info');
         $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
      }
      return redirect("admin/listNews");
   }
   public function allUser(Request $request)
   {
      $users_obj = new Users();
      //$where = 'where loginType = 3';
        $query = $users_obj->select('*');

        if($request->has('searchsubmit') && !empty($request->status))
        {
          if($request->status == "hold")
          {
            $status = 0;
          }else{
            $status = $request->status;
          }
           //$where .= ' and status = '.$status;
           //$users = DB::select("SELECT * FROM Users $where");
           $query->where('status',$status);
        }
        if($request->has('searchsubmit') && !empty($request->email))
        {
          #echo "email";die;
          $query->where('email','like','%'.$request->email.'%');
        }
        if($request->has('searchsubmit') && !empty($request->telephone))
        {
          $query->where('telephone','like','%'.$request->telephone.'%');
        }
        if($request->has('searchsubmit') && !empty($request->firstname))
        {
          $query->where('firstname','like','%'.$request->firstname.'%');
        }
        if($request->has('searchsubmit') && !empty($request->lastname))
        {
          $query->where('lastname','like','%'.$request->lastname.'%');
        }
        $users = $query->orderBy('id','desc')->paginate(10);
        #dd(DB::getQueryLog());
        $q_gett = DB::getQueryLog();
        #echo "<pre>";print_r($q_gett);die;
        $data['heading'] = trans('messages.User List');
      return view("admin.allUser")->with(array("data"=> $data,"userList"=>$users));
   }
   public function blockedUser(Request $request)
   {
      $users_obj = new Users();
      //$where = 'where loginType = 3';
        $query = $users_obj->select('*');

        if($request->has('searchsubmit') && !empty($request->status))
        {
          if($request->status == "hold")
          {
            $status = 0;
          }else{
            $status = $request->status;
          }
           //$where .= ' and status = '.$status;
           //$users = DB::select("SELECT * FROM Users $where");
           $query->where('status',$status);
        }
        if($request->has('searchsubmit') && !empty($request->email))
        {
          #echo "email";die;
          $query->where('email','like','%'.$request->email.'%');
        }
        if($request->has('searchsubmit') && !empty($request->telephone))
        {
          $query->where('telephone','like','%'.$request->telephone.'%');
        }
        if($request->has('searchsubmit') && !empty($request->firstname))
        {
          $query->where('firstname','like','%'.$request->firstname.'%');
        }
        if($request->has('searchsubmit') && !empty($request->lastname))
        {
          $query->where('lastname','like','%'.$request->lastname.'%');
        }
        $query->where('status','=',2);
        $users = $query->orderBy('id','desc')->paginate(10);
        #dd(DB::getQueryLog());
        $q_gett = DB::getQueryLog();
        #echo "<pre>";print_r($q_gett);die;
        $data['heading'] = trans('messages.Blocked User');
      return view("admin.blockedUser")->with(array("data"=> $data,"userList"=>$users));
   }
   public function allManager(Request $request)
   {
      $users_obj = new Managers();
      //$where = 'where loginType = 3';
        $query = $users_obj->select('*');

        if($request->has('searchsubmit') && !empty($request->status))
        {
          if($request->status == "hold")
          {
            $status = 0;
          }else{
            $status = $request->status;
          }
           //$where .= ' and status = '.$status;
           //$users = DB::select("SELECT * FROM Users $where");
           $query->where('status',$status);
        }
        if($request->has('searchsubmit') && !empty($request->email))
        {
          #echo "email";die;
          $query->where('email','like','%'.$request->email.'%');
        }
        if($request->has('searchsubmit') && !empty($request->telephone))
        {
          $query->where('telephone','like','%'.$request->telephone.'%');
        }
        if($request->has('searchsubmit') && !empty($request->firstname))
        {
          $query->where('firstname','like','%'.$request->firstname.'%');
        }
        if($request->has('searchsubmit') && !empty($request->lastname))
        {
          $query->where('lastname','like','%'.$request->lastname.'%');
        }
        $users = $query->orderBy('id','desc')->paginate(10);
        #dd(DB::getQueryLog());
        $q_gett = DB::getQueryLog();
        #echo "<pre>";print_r($q_gett);die;
        $data['heading'] = trans('messages.Manager List');
      return view("admin.allManager")->with(array("data"=> $data,"userList"=>$users));
   }
   public function blockedManager(Request $request)
   {
      $users_obj = new Managers();
      //$where = 'where loginType = 3';
        $query = $users_obj->select('*');

        if($request->has('searchsubmit') && !empty($request->status))
        {
          if($request->status == "hold")
          {
            $status = 0;
          }else{
            $status = $request->status;
          }
           //$where .= ' and status = '.$status;
           //$users = DB::select("SELECT * FROM Users $where");
           $query->where('status',$status);
        }
        if($request->has('searchsubmit') && !empty($request->email))
        {
          #echo "email";die;
          $query->where('email','like','%'.$request->email.'%');
        }
        if($request->has('searchsubmit') && !empty($request->telephone))
        {
          $query->where('telephone','like','%'.$request->telephone.'%');
        }
        if($request->has('searchsubmit') && !empty($request->firstname))
        {
          $query->where('firstname','like','%'.$request->firstname.'%');
        }
        if($request->has('searchsubmit') && !empty($request->lastname))
        {
          $query->where('lastname','like','%'.$request->lastname.'%');
        }
        $query->where('status','=',2);
        $users = $query->orderBy('id','desc')->paginate(10);
        #dd(DB::getQueryLog());
        $q_gett = DB::getQueryLog();
        #echo "<pre>";print_r($q_gett);die;
        $data['heading'] = trans('messages.Manager List');
      return view("admin.blockedManager")->with(array("data"=> $data,"userList"=>$users));
   }
   public function logout(Request $request){
    $request->session()->flush();
       return redirect ("admin");
   }
   public function eventAttendance(Request $request)
   {
    $date = date("Y-m-d H:i:s");
      $Events_obj = new Events();
      $data["record"] = $Events_obj->select("events.*","clubs.club_name")
                  ->where("events.start_date_time","<",$date)
                  ->join("clubs","events.club_id","clubs.id")
                  ->orderBy("events.id","desc")
                  ->paginate(10);
      /*$gett = DB::getQueryLog();
      echo "<pre>";print_r($gett);die;*/
      $data["heading"] = trans("messages.eventAttendance");
      return view("admin/eventAttendance")->with(array("data"=>$data));
   }
   public function eventAllUser(Request $request,$id)
   {
    $id = Crypt::decryptString($id);
    #echo $id;
    $date = date("Y-m-d H:i:s");
      $Events_obj = new Event_attendance();
      $data["record"] = $u_r = $Events_obj
                  ->select("event_attendance.id","users.firstname","users.lastname","users.email","users.telephone")
                  ->where("event_attendance.event_id",$id)
                  ->join("users","users.id","event_attendance.user_id")
                  ->orderBy("event_attendance.id","desc")
                  ->paginate(10);
      /*$gett = DB::getQueryLog();
      echo "<pre>";print_r($gett);die;*/
      #echo "<pre>";print_r($data["record"]);die;
      $data["heading"] = trans("messages.eventAllUser");
      return view("admin/eventAllUser")->with(array("data"=>$data,"userList"=>$u_r));
   }
   public function galleryEvent(Request $request)
   {
    $date = date("Y-m-d H:i:s");
      $Events_obj = new Events();
      $data["record"] = $Events_obj->select("events.*","clubs.club_name")
                  ->where("events.start_date_time","<",$date)
                  ->join("clubs","events.club_id","clubs.id")
                  ->orderBy("events.id","desc")
                  ->paginate(10);
      /*$gett = DB::getQueryLog();
      echo "<pre>";print_r($gett);die;*/
      $data["heading"] = trans("messages.galleryEvent");
      return view("admin/galleryEvent")->with(array("data"=>$data));
   }
   public function userGallery(Request $request,$id)
   {
    $id = Crypt::decryptString($id);
    #echo $id;
    $date = date("Y-m-d H:i:s");
      $Events_obj = new Gallery();
      $data["id"] = $id;
      $data["record"] = $u_r = $Events_obj
                  ->select("galleries.id","galleries.is_admin","galleries.admin_id","galleries.event_id","galleries.user_id","users.firstname","users.lastname","users.email","users.telephone")
                  ->where("galleries.event_id",$id)
                  ->leftJoin("users","users.id","galleries.user_id")
                  ->orderBy("galleries.id","desc")
                  ->groupBy("galleries.user_id")
                  ->paginate(10);
      #$gett = DB::getQueryLog();
      #echo "<pre>";print_r($gett);die;
      #echo "<pre>";print_r($data["record"]);die;
      $data["heading"] = trans("messages.userGallery");
      return view("admin/userGallery")->with(array("data"=>$data,"userList"=>$u_r));
   }
   public function allPicture(Request $request,$id)
   {
      #echo $is_admin;die;
      //$user_id = Crypt::decryptString($user_id);
      //$event_id = Crypt::decryptString($event_id);
      $id = Crypt::decryptString($id);
      $data["id"] = $id;
      $Events_obj = new Gallery();
      /*if($is_admin == 0)
      {
        $record = $Events_obj->where("user_id",$user_id)->where("event_id",$event_id)->where("is_admin",0)->paginate(10);
      }else{
        $record = $Events_obj->where("event_id",$event_id)->where("is_admin",1)->paginate(10);
      }*/
        $record = $Events_obj->where("parent_id",$id)->paginate(10);
      /*$gett = DB::getQueryLog();
      print_r($gett);*/
      #echo "<pre>";print_r($record);
      $data["heading"] = trans("messages.allPicture");
      /*$data["user_id"] = $user_id;
      $data["event_id"] = $event_id;
      $data["is_admin"] = $is_admin;*/
      return view("admin/allPicture")->with(array("data"=>$data,"userList"=>$record));
   }
   public function galleryPicture(Request $request,$id)
   {
      #echo $is_admin;die;
      /*$user_id = Crypt::decryptString($user_id);
      $event_id = Crypt::decryptString($event_id);*/

      $Events_obj = new Gallery();
      /*if($is_admin ==0)
      {
        $record = $Events_obj->where("user_id",$user_id)->where("event_id",$event_id)->where("is_admin",0)->where("upload",1)->get();
      }else{
        $record = $Events_obj->where("event_id",$event_id)->where("is_admin",1)->where("upload",1)->get();
      }*/
        $record = $Events_obj->where("parent_id",$id)->where("upload",1)->get();
      
      #echo "<pre>";print_r($record);
      $data["heading"] = trans("messages.Gallery Slider");
      ///$data["user_id"] = $user_id;
      //$data["event_id"] = $event_id;
      return view("admin/galleryPicture")->with(array("data"=>$data,"userList"=>$record));
   }
   public function galleryApprovel(Request $request)
   {
      #echo "<pre>";print_r($request->all());die;
      $Gallery_obj = new Gallery();
      $is_admin = $request->is_admin;
      $gallery_id = $request->gallery_id;
      $submit = $request->submit;
      $e_id = Crypt::encryptString($request->id);
      //$event_id = Crypt::encryptString($request->event_id);
      if($gallery_id)
      {
        if($submit == "Approved")
        {
          #echo "app";
          $status = 1;
        }else{
          #echo "reject";
          $status = 2;
        }
        $response = 0;
        for ($i=0; $i <count($gallery_id); $i++)
        { 
          $update_array = array(
              "status" => $status
          );
          $response = $Gallery_obj->where("id",$gallery_id[$i])->update($update_array);
        }
        if($response == 1)
        {
          $message =  trans('messages.Record updated successfully');
          $request->session()->flash("message","<div class='alert alert-success'><strong>".$message."</strong></div>");
        }else{
          $message =  trans('messages.went_wrong');
          $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
        }
      }else{
        $message =  trans('messages.Please select image');
        $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
      }
      return redirect("admin/allPicture".'/'.$e_id);
   }
   public function editHomeMusicSubmit(Request $request)
   {
      try{
        $Setting_obj = new Setting();
        #echo "<pre>";print_r($_FILES);die;
        if($_FILES["image"]["size"] > 0)
        {
            $ext_var = $_FILES["image"]["name"];
            $explode_var = explode(".",$ext_var);
            $extension = strtolower($explode_var[1]);
            if($extension == "mp3")
            {
              if($request->old_image)
              {
                 $old_image = public_path('/upload/home/'.$request->old_image);
                  if(file_exists($old_image))
                  {
                    unlink($old_image);
                  }
              }
             
                $image = $request->file('image');
                $ext = $image->getClientOriginalExtension();
                $img_name = 'home'.'_'.substr(md5(time()), 0, 4).'.'.$ext;
                $banner_path = public_path('/upload/home/');
                $image->move($banner_path,$img_name);
                #echo $img_name;die;
                $id = $request->i;
                $id = Crypt::decryptString($id);
                $update_array = array(
                  "meta_value" => $img_name
                );
                $response = $Setting_obj->where("id",$id)->update($update_array);
                #$gett = DB::getQueryLog();
                /*echo "<pre>";print_r($gett);
                echo $response;die;*/
                if($response == 1)
                {
                  $message =  trans('messages.Record updated successfully');
                  $request->session()->flash("message","<div class='alert alert-success'><strong>".$message."</strong></div>");
                }else{
                  $message =  trans('messages.went_wrong');
                  $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
                }
            }else{
                $message = trans('messages.Only mp3 file you can upload');
                $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
            }
        }else{
          $message = trans('messages.Please select file');
          $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
        }

      }catch(DecryptException $e){
         $message = trans('messages.invalid_info');
         $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
      }
      return redirect("admin/editHomeMusic");
   
   }
   public function info(Request $request)
   {
      try{
        $Info_obj = new Info();
        $record = $Info_obj->where("id",1)->get()->toArray();
          $data["heading"] = trans("messages.info");
          #echo "<pre>";print_r($record);die;
        }catch(DecryptException $e){
         $message = trans('messages.invalid_info');
         $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
      }
      return view("admin/info")->with(array("data"=>$data,"record"=>$record));
   }
   public function infoSubmit(Request $request)
   {
      $validatedData = $request->validate([
           'title' => 'required',
           'detail'   => 'required',
           'sub_title'   => 'required',
           'mobile'   => 'required',
           'email'   => 'required',
           'friday_open_time'   => 'required',
           'friday_close_time'   => 'required',
           'saturday_open_time'   => 'required',
           'saturday_close_time'   => 'required',
           'address'   => 'required',
           'facebook_link'   => 'required',
           'instagram_link'   => 'required',
           'google_link'   => 'required',
        ]);
      #echo "<pre>";print_r($request->all());
      $latitude = $request->latitude;
      $longitude = $request->longitude;
      if(empty($latitude) || empty($longitude))
      {
        $message =  trans('messages.google_address_error');
        $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
      }else{
          $array_data = array(
            "title" => $request->title,
            "sub_title" => $request->sub_title,
            "mobile" => $request->mobile,
            "email" => $request->email,
            "friday_open_time" => $request->friday_open_time,
            "friday_close_time" => $request->friday_close_time,
            "saturday_open_time" => $request->saturday_open_time,
            "saturday_close_time" => $request->saturday_close_time,
            "address" => $request->address,
            "latitude" => $request->latitude,
            "longitude" => $request->longitude,
            "facebook_link" => $request->facebook_link,
            "instagram_link" => $request->instagram_link,
            "google_link" => $request->google_link,
            "detail" => $request->detail
        );
        $Info_obj = new Info();
        $response = $Info_obj->where("id",1)->update($array_data);
        if($response == 1)
        {
          $message =  trans('messages.Record updated successfully');
          $request->session()->flash("message","<div class='alert alert-success'><strong>".$message."</strong></div>");
        }else{
          $message =  trans('messages.went_wrong');
          $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
        }
      }
      return redirect("admin/info");
   }

   public function sendPush(Request $request)
  {
    $Users_obj = new Users();
    $record = $Users_obj->select("id","firstname","lastname")->where("status",1)->orderBy("id","DESC")->get()->toArray();
    $data["heading"] = trans("messages.Push Notification");
    $data["record"] = $record;
      return view("admin.sendPush")->with(array("data"=>$data));
  }
  public function sendPushSubmit(Request $request)
  {
    #echo "<pre>";print_r($request->all());die;
    $validatedData = $request->validate([
       'users'=>'required',
       'message'=>'required',
    ]);
    $users = $request->users;
    $all_users = implode(",",$users);
    $message = $request->message;
    $arr = array("user_id"=>$all_users,"messages"=>$message);

    $Pushnotification_obj = new Pushnotification($arr);
    $Pushnotification_obj->save();

    $driver_obj = new Users();
    for($x=0; $x<count($users); $x++)
    {
      $id = $users[$x];
      $driver_record = $driver_obj->select("deviceToken")->where("id",$id)->first();
      if($driver_record)
      {
        $deviceToken = $driver_record->deviceToken;
        if(!empty($deviceToken))
        {
           //app = 0(User) app=1(Driver)
           $m_p = $message;
           $second_arr = array("fcm_push_error"=>"false","fcm_push_response"=>"admin side message","title"=>"TNT","message"=>$m_p);
           $arr = array("token"=>$deviceToken,"app"=>0,"title"=>"TNT","message"=>$m_p);
           $pushNotification = new PushMessageCustom();
           $pushNotification->sendPush($arr,$second_arr);
        }
      }
    }
    $message =  trans('messages.Message send successfully');
          $request->session()->flash("message","<div class='alert alert-success'><strong>".$message.".</strong></div>");
    return redirect("admin/sendPush");      
  }
  public function listPush(Request $request)
  {
    $user_name = array();
    $Pushnotification_obj = new Pushnotification();
    $Users_obj = new Users();
    $query = $Pushnotification_obj->select("*");

    if($request->has('searchsubmit') && !empty($request->messages))
    {
      $query->where('messages','like','%'.$request->messages.'%');
    }
    if($request->has('searchsubmit') && !empty($request->from_date)&& !empty($request->to_date))
    {
        $from_date = $request->from_date;
        $to_date = $request->to_date;
        
        //$from_date = date('Y-m-d', strtotime(str_replace('/', '-', $request->from_date)));
        //echo $from_date;
        #echo $to_date;
        //die;

        //$to_date = date("Y-m-d",strtotime($to_date));
        
        $ar = array($from_date,$to_date);
        $query->whereBetween('created_at',$ar);
    }



    $record = $query->paginate(10);
    /*$gett = DB::getQueryLog();
    echo "<pre>";print_r($gett);*/
    #echo "<pre>";print_r($record);die;
    $x=0;
    foreach($record as $value)
    {
        $ext_user = $user_name = array();
        $ext_user = explode(",",$value["user_id"]);
        for ($i=0; $i <count($ext_user); $i++)
        { 
            $rec = $Users_obj->select("id","firstname","lastname")->where("id",$ext_user[$i])->get()->toArray();
            if(count($rec)>0)
            {
                $user_name[] = $rec[0]["firstname"]." ".$rec[0]["lastname"];
            }
        }
        $record[$x]["user_names"] = implode(",",$user_name);
        $x++;
    }
    $data["heading"] = trans("messages.listPush");
    $data["record"] = $record;
    return view("admin.listPush")->with(array("data"=>$data));


  }
  public function deletePush(Request $request,$id)
  {
        $Pushnotification_obj = new Pushnotification();
        $response = $Pushnotification_obj->where("id",$id)->delete();
        if($response == 1)
        {
          $message =  trans('messages.Record deleted successfully');
          $request->session()->flash("message","<div class='alert alert-success'><strong>".$message."</strong></div>");
        }else{
          $message =  trans('messages.went_wrong');
          $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
        }
        return redirect("admin/listPush");
  }
  public function listClub(Request $request)
  {
    $data["heading"] = trans("messages.listClub");
    $Clubs = new Clubs();



      $query = $Clubs->select("clubs.*",);

            if($request->has('searchsubmit') && !empty($request->club_name))
            {
              $query->where('clubs.club_name','like','%'.$request->club_name.'%');
              
            }

            if($request->has('searchsubmit') && !empty($request->address))
            {
              $query->where('clubs.address','like','%'.$request->address.'%');
            }

            if($request->has('searchsubmit') && !empty($request->from_date)&& !empty($request->to_date))
            {
                $from_date = $request->from_date;
                $to_date = $request->to_date;
                
                //$from_date = date('Y-m-d', strtotime(str_replace('/', '-', $request->from_date)));
                //echo $from_date;
                #echo $to_date;
                //die;

                //$to_date = date("Y-m-d",strtotime($to_date));
                
                $ar = array($from_date,$to_date);
                $query->whereBetween('clubs.created_at',$ar);
            }
        $data["record"] = $query->paginate(10);

    return view("admin.listClub")->with(array("data"=>$data));
  }
  public function deleteMusic(Request $request)
  {
      $Setting_obj = new Setting();
      $rec = $Setting_obj->where("id",1)->get()->toArray();
      $meta_value = "";
      if(count($rec)>0)
      {
        $meta_value = $rec[0]["meta_value"];
      }
      if($meta_value)
      {
        $old_image = public_path('/upload/home/'.$meta_value);
              
        if(file_exists($old_image))
        {
          unlink($old_image);
        }
      }
      
        
        #echo $img_name;die;
        
        $update_array = array(
          "meta_value" => NULL
        );
        $response = $Setting_obj->where("id",1)->update($update_array);
        #$gett = DB::getQueryLog();
        /*echo "<pre>";print_r($gett);
        echo $response;die;*/
        if($response == 1)
        {
          $message =  trans('messages.Record updated successfully');
          $request->session()->flash("message","<div class='alert alert-success'><strong>".$message."</strong></div>");
        }else{
          $message =  trans('messages.went_wrong');
          $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
        }
        return redirect("admin/editHomeMusic");
  }
  public function uploadGalleryImage(Request $request)
  {
      #$data["event_id"] = Crypt::decryptString($event_id);
      $data["event_id"] = 0;
      #echo $event_id;
      $Gallery_obj = new Gallery();
      $data["isExist"] = $Gallery_obj->select("galleries.id","galleries.title")->where("parent_id",0)->groupBy("title")->orderby("id","DESC")->get()->toArray();
      $data["heading"] = trans("messages.Upload gallery & video");
      return view("admin.uploadGalleryImage")->with(array("data"=>$data));
  }

  public function updatePoint(Request $request,$user_id)
  {
      $user_id = Crypt::decryptString($user_id);
      #echo $event_id;
      $Users_obj = new Users(); 
      $data["user_record"] = $Users_obj->select("id","total_points")->where("id",$user_id)->get()->toArray();
      #print_r($data["user_record"]);
      $data["heading"] = trans("messages.updatePoint");
      return view("admin.updatePoint")->with(array("data"=>$data));
  }
  public function pointSetting(Request $request)
  {
      $Setting_obj = new Setting();
      $data["record"] = $Setting_obj->select("*")->where("id",2)->get()->toArray();
      #print_r($data["user_record"]);
      $data["heading"] = trans("messages.pointSetting");
      return view("admin.pointSetting")->with(array("data"=>$data));
  }
  public function updatePointSubmit(Request $request)
  {
     
      $Users_obj = new Users(); 
      $enc_user_id = Crypt::encryptString($request->user_id);
        if($request->total_points < 0)
        {
          $message =  trans('messages.Point can not be less then zero');
          $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
          return redirect("admin/updatePoint"."/".$enc_user_id);
        }
        #echo $img_name;die;
        
        $update_array = array(
          "total_points" => $request->total_points
        );
        $response = $Users_obj->where("id",$request->user_id)->update($update_array);
        #$gett = DB::getQueryLog();
        /*echo "<pre>";print_r($gett);
        echo $response;die;*/
        if($response == 1)
        {
          $message =  trans('messages.Record updated successfully');
          $request->session()->flash("message","<div class='alert alert-success'><strong>".$message."</strong></div>");
        }else{
          $message =  trans('messages.went_wrong');
          $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
        }
        return redirect("admin/allUser");
  }
  public function pointSettingSubmit(Request $request)
  {
     
      $Setting_obj = new Setting();
        if($request->global_point < 0)
        {
          $message =  trans('messages.Point can not be less then zero');
          $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
          return redirect("admin/pointSetting");
        }
        #echo $img_name;die;
        
        $update_array = array(
          "meta_value" => $request->global_point
        );
        $response = $Setting_obj->where("id",2)->update($update_array);
        #$gett = DB::getQueryLog();
        /*echo "<pre>";print_r($gett);
        echo $response;die;*/
        if($response == 1)
        {
          $message =  trans('messages.Record updated successfully');
          $request->session()->flash("message","<div class='alert alert-success'><strong>".$message."</strong></div>");
        }else{
          $message =  trans('messages.went_wrong');
          $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
        }
        return redirect("admin/pointSetting");
  }

  public function uploadGallerySubmit(Request $request)
  {
    /*echo "<pre>";
    print_r($_POST);
    die;*/
    /*echo "<pre>";
    print_r($_POST);
    //echo $_FILES["image"]["name"][0];
    //echo $_FILES["image"]["name"][1];
    //echo count($_FILES["image"]["name"]);
    print_r($_FILES);die;*/
    $type = $request->type;
    if($type == 1)
    {
       $validatedData = $request->validate([
         'title'=>'required',
         'type'=>'required'
      ]); 
    }else{
      $validatedData = $request->validate([
         'old_title'=>'required',
         'type'=>'required'
      ]);
    }

    
    if($_FILES["image"]["name"] || $_FILES["video"]["name"])
    {
        $image_error = 0;
        $no_image_error = 0;
        for ($i=0; $i <count($_FILES["image"]["name"]); $i++)
        { 
            if($_FILES["image"]["size"][$i] > 0)
            {
                $ext_var = $_FILES["image"]["name"][$i];
                $explode_var = explode(".",$ext_var);
                #print_r($explode_var);
                $less_var = count($explode_var) - 1;

                #echo "explode_var".count($explode_var);
                #echo "less_var".$less_var;
                $extension = strtolower($explode_var[$less_var]);
                
                if($extension == "jpg" || $extension == "jpeg" || $extension == "gif" || $extension == "png" || $extension == "tif")
                {
                    $image_error = 0;
                }else{
                    $image_error = 1;
                }
            }else{
              $no_image_error = 1;
            }
        }
        $video_error = 0;
        $no_video_error = 0;
        for ($i=0; $i <count($_FILES["video"]["name"]); $i++)
        { 
            if($_FILES["video"]["size"][$i] > 0)
            {
                $ext_var = $_FILES["video"]["name"][$i];
                $explode_var = explode(".",$ext_var);
                $less_var = count($explode_var) - 1;
                $extension = strtolower($explode_var[$less_var]);
                //echo $extension;
                if($extension == "mp4" || $extension == "mp3" || $extension == "ogg" || $extension == "wmv" || $extension == "webm" || $extension == "flv" || $extension == "avi"|| $extension == "gif")
                {
                    $video_error = 0;
                }else{
                    $video_error = 1;
                }
            }else{
              $no_video_error = 1;
            }
        }
        
        #die;
        if($no_image_error == 1 && $no_video_error == 1)
        {
            $message =  trans('messages.Image or video is required');
            $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message.".</strong></div>");
            //$event_id = Crypt::encryptString($request->event_id);
            //return redirect("admin/uploadGalleryImage"."/".$event_id); 
            return redirect("admin/uploadGalleryImage"); 
        }
        /*echo "image_error".$image_error;
        echo "video_error".$video_error;
        die;*/
        if($image_error == 1)
        {
            $message =  trans('messages.image_type_error');
                $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message.".</strong></div>");
        }else if($video_error == 1){
          $message =  trans('messages.video_type_error');
                $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message.".</strong></div>");
        }else{
            $file_name = array();
            for ($i=0; $i <count($_FILES["image"]["name"]); $i++)
            { 
                if($_FILES["image"]["size"][$i] > 0)
                {
                    $ext_var = $_FILES["image"]["name"][$i];
                    $explode_var = explode(".",$ext_var);
                    #print_r($explode_var);die;
                    $less_var = count($explode_var) - 1;
                    $extension = strtolower($explode_var[$less_var]);
                    $image = $_FILES["image"]["name"][$i];
                    $random = substr(md5(mt_rand()), 0, 4);
                    $file_name[] = $input['imagename'] = time().$random.'.'.$extension;
                    #echo 
                    $destinationPath = public_path('/upload/gallery');
                    //$image->move($destinationPath, $input['imagename']);
                    move_uploaded_file($_FILES["image"]["tmp_name"][$i], $destinationPath."/".$input['imagename']);

                
                }
            }



            if(count($file_name)>0)
            {
              for ($y=0; $y <count($file_name); $y++)
              {
                $img11 = Image::make(public_path('/upload/gallery'.'/'.$file_name[$y]));
                $img11->insert(public_path('/download.jpg'), 'bottom-right', 10, 10);
                $img11->save(public_path('/upload/gallery'.'/'.$file_name[$y])); 
                //$img11->save(public_path('/upload/gallery/'.$img11)); 
                //echo 'Suces';die;
              }
            }


            $video_file_name = array();
            for ($i=0; $i <count($_FILES["video"]["name"]); $i++)
            { 
                if($_FILES["video"]["size"][$i] > 0)
                {
                    $ext_var = $_FILES["video"]["name"][$i];
                    $explode_var = explode(".",$ext_var);
                    #print_r($explode_var);die;
                    $less_var = count($explode_var) - 1;
                    $extension = strtolower($explode_var[$less_var]);
                    $video = $_FILES["video"]["name"][$i];
                    $random = substr(md5(mt_rand()), 0, 4);
                    $video_file_name[] = $input['videoname'] = time().$random.'.'.$extension;
                    #echo 
                    $destinationPath = public_path('/upload/gallery');
                    move_uploaded_file($_FILES["video"]["tmp_name"][$i], $destinationPath."/".$input['videoname']);

                
                }
            }


            #$image = implode(",", $file_name);
            $admin_id = $request->session()->get('id');
            //echo $input['imagename']."form submit";
            $event_id = $request->event_id;
            $query_response = 0;
            for ($y=0; $y <count($file_name); $y++)
            {
              //$explode_var = explode(".",$file_name[$y]);
              #print_r($explode_var);die;
              //$extension = strtolower($explode_var[1]);
              /*if($extension == "jpg" || $extension == "jpeg" || $extension == "gif" || $extension == "png" || $extension == "tif")
              {}else{}*/
              $title = $request->title;
              if($type == 1)
              {
                $parent_id = 0;
              }else{
                $Gallery_obj = new Gallery();
                $recccccc = $Gallery_obj->select("title")->where("id",$request->old_title)->get()->toArray();
                if(count($recccccc)>0)
                {
                  $title = $recccccc[0]["title"];
                }else{
                  $title = NULL;
                }
                $parent_id = $request->old_title;
              }
                $insert_data = array(
                    "parent_id" => $parent_id,
                    "admin_id" => $admin_id,
                    "image" => $file_name[$y],
                    #"event_id" => $event_id,
                    "event_id" => 0,
                    "title" => $title,
                    "upload" => 1,
                    "user_id" => 0,
                    "status" => 1,
                    "is_admin" => 1,
                );
                $Gallery_obj = new Gallery($insert_data);
                $query_response = $Gallery_obj->save();
            }
            for ($y=0; $y <count($video_file_name); $y++)
            {
              //$explode_var = explode(".",$video_file_name[$y]);
              #print_r($explode_var);die;
              //$extension = strtolower($explode_var[1]);
              /*if($extension == "jpg" || $extension == "jpeg" || $extension == "gif" || $extension == "png" || $extension == "tif")
              {}else{}*/

              $title = $request->title;
              if($type == 1)
              {
                $parent_id = 0;
              }else{
                $Gallery_obj = new Gallery();
                $recccccc = $Gallery_obj->select("title")->where("id",$request->old_title)->get()->toArray();
                if(count($recccccc)>0)
                {
                  $title = $recccccc[0]["title"];
                }else{
                  $title = NULL;
                }
                $parent_id = $request->old_title;
              }
              
                $insert_data = array(
                    "parent_id" => $parent_id,
                    "admin_id" => $admin_id,
                    "image" => $video_file_name[$y],
                    #"event_id" => $event_id,
                    "event_id" => 0,
                    "title" => $title,
                    "upload" => 2,
                    "user_id" => 0,
                    "status" => 1,
                    "is_admin" => 1,
                );
                $Gallery_obj = new Gallery($insert_data);
                $query_response = $Gallery_obj->save();
            }

            #echo "here";die;
            if($query_response == 1)
            {
                $message =  trans('messages.sucess');
                $request->session()->flash("message","<div class='alert alert-success'><strong>".$message.".</strong></div>");
            }else{
                 
                $message =  trans('messages.query');
                $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message.".</strong></div>");
            }
        }
    }else{
        #echo "else";die;

        $message =  trans('messages.Image or video is required');
        $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message.".</strong></div>");
    }                
    #$message =  trans('messages.Message send successfully');
    #$request->session()->flash("message","<div class='alert alert-success'><strong>".$message.".</strong></div>");
    //$event_id = Crypt::encryptString($request->event_id);
    #return redirect("admin/uploadGalleryImage"."/".$event_id);      
    return redirect("admin/uploadGalleryImage");      
  }

public function getGallery(Request $request)
{

      //$event_id = $request->event_id;
      $Gallery_obj = new Gallery();
      $isExist = $Gallery_obj->select("galleries.*")->where("parent_id",0)->where("status",1)->orderby("id","DESC")->paginate(10);
    
          /*$y=0;
          $all_image = array();
          foreach ($isExist as $key => $value)
          {
              $isExist[$y]["image"] = url("public/upload/gallery")."/".$value["image"];
                  
              $isExist[$y]["date"] = strftime("%d %B, %Y",strtotime($value["created_at"]));
              #$isExist[$y]["date"] = date("d/m/Y",strtotime($value["created_at"]));
              $y++;
          }*/
          $data["record"]  = $isExist;
          //$data->all_image  = $all_image;
      
        $data["heading"] = trans("messages.getGallery");
        return view("admin.getGallery")->with(array("data"=>$data));
        
        
    }

public function getPointlist(Request $request)
{

      $Event_attendance_obj = new Event_attendance();
            $q = $Event_attendance_obj->select("event_attendance.*","users.firstname","users.lastname");
          $q->leftJoin("users","users.id","event_attendance.user_id");  
        $data["record"] = $q->groupBy("today_dates")->paginate(10);
        $x=0;
        foreach($data["record"] as $val)
        {
          $sum = 0;
            $sum = $Event_attendance_obj->where("today_dates",$val["today_dates"])->sum("points");
          $data["record"][$x]["point"] = $sum;
          $x++;
        }
        #echo "hello";print_r($record);die;
        $data["heading"] = trans("messages.getPointlist");
        return view("admin.getPointlist")->with(array("data"=>$data));
        
        
    }

public function getPointdetail(Request $request,$dates)
{

      $Event_attendance_obj = new Event_attendance();
            $q = $Event_attendance_obj->select("event_attendance.*","users.firstname","users.lastname");
          $q->leftJoin("users","users.id","event_attendance.user_id");
          $q->where("today_dates",$dates);
        $data["record"] = $q->paginate(10);
        $x=0;
        /*foreach($data["record"] as $val)
        {
          $sum = 0;
            $sum = $Event_attendance_obj->where("today_dates",$val["today_dates"])->sum("points");
          $data["record"][$x]["point"] = $sum;
          $x++;
        }*/
        #echo "hello";print_r($record);die;
        $data["heading"] = trans("messages.getPointdetail");
        return view("admin.getPointdetail")->with(array("data"=>$data));
        
        
    }


}



