<?php

namespace App\Http\Controllers\admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Crypt;
use Illuminate\Contracts\Encryption\DecryptException;
use App\Banner;


class BannerController extends Controller
{
   public function __construct()
   {
      //DB::enableQueryLog();
   }

   public function addBannerSubmit(Request $request)
   {
      $validatedData = $request->validate([
         'image'   => 'required|image',
      ]);

      if($_FILES['image']['size'] != 0){
         $image = $request->file('image');
         $ext = $image->getClientOriginalExtension();
         $img_name = 'banner'.'_'.substr(md5(time()), 0, 4).'.'.$ext;
         $banner_path = public_path('/upload/banner/');
         $image->move($banner_path,$img_name);

      }
      
      $insert_array = array("image" =>$img_name);
      $banner_obj = new Banner();
      $response = $banner_obj->insert_record($insert_array);
      if($response == 1)
      {
         $message =  trans('messages.Banner added successfully');
         $request->session()->flash("message","<div class='alert alert-success'><strong>".$message."</strong></div>");
      }else{
         $message =  trans('messages.went_wrong');
         $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
      }
      return redirect("admin/listBanner");
   }

   public function editBannerSubmit(Request $request)
   {
    $validatedData = $request->validate([
         'image'   => 'required|image',
      ]);

      try{
         $id = Crypt::decryptString($request->i);
         $where = array('id' => $id);
         $banner_obj = new Banner();
         $isExist = $banner_obj->getCount($where);
         if($isExist){
            $img_name = '';
            $banner_detail = $banner_obj->get_record_single($where);

            if(isset($_FILES['image']['name'])){
               if($_FILES['image']['size'] != 0){ 
                  /* Unlink old banner */
                  $old_file = public_path('/upload/banner/'.$banner_detail->image);
                  if(file_exists($old_file)){
                     unlink($old_file);
                  }
                  $image = $request->file('image');
                  $ext = $image->getClientOriginalExtension();
                  $img_name = 'banner'.'_'.substr(md5(time()), 0, 4).'.'.$ext;
                  $banner_path = public_path('/upload/banner/');
                  $image->move($banner_path,$img_name);


                  /***********/
               }
            }

            
            if(!empty($img_name)){
               $update_array["image"] = $img_name;
            }
            $response = $banner_obj->update_record($where,$update_array);
            if($response == 1)
            {
               $message =  trans('messages.Banner updated successfully');
               $request->session()->flash("message","<div class='alert alert-success'><strong>".$message."</strong></div>");
            }else{
               $message =  trans('messages.went_wrong');
               $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
            }
         }else{
            $message =  trans('messages.went_wrong');
            $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
         }
      }catch(DecryptException $e){
         $message = trans('messages.invalid_info');
         $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
      }
      return redirect("admin/listBanner");
   }

   public function updateBanner(Request $request,$i){
      try{
         $id = Crypt::decryptString($i);
         $where = array('id' => $id);
         $banner_obj = new Banner();
         $isExist = $banner_obj->getCount($where);
         if($isExist){
            $bannerDetail = $banner_obj->get_record_single($where);
            $update_array['status'] = '1';
            if($bannerDetail->status){
                $update_array['status'] = '0';
            }
            $response = $banner_obj->update_record($where,$update_array);
            if($response == 1)
            {
               $message =  trans('messages.Banner status updated successfully');
               $request->session()->flash("message","<div class='alert alert-success'><strong>".$message."</strong></div>");
            }else{
               $message =  trans('messages.went_wrong');
               $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
            }
         }else{
            $message =  trans('messages.went_wrong');
            $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
         }
      }catch(DecryptException $e){
         $message = trans('messages.invalid_info');
         $request->session()->flash("message","<div class='alert alert-danger'><strong>".$message."</strong></div>");
      }
      return redirect("admin/listBanner");
   }
   
  
}
