<?php

namespace App\Http\Controllers\api;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Response;
use App\Http\Utility\Common;
use App\Http\Service\DataService;
use App\Http\Utility\Defaults;
use Illuminate\Support\Str;
use Validator;
use App\Users;
use App\Usertoken;
use App\Gallery;
use App\Events;
use App\Event_attendance;
use App\NewsModel;
use App\Setting;
use App\Info;
use DB;
use App\Clubs;
use App\Banner;
use App\Mail\DemoEmail;
use Illuminate\Support\Facades\Mail;
use Intervention\Image\ImageManagerStatic as Image;

class ApiController extends Controller
{
 public function __construct()
 {
   DB::enableQueryLog();
 }

public function homeApi(request $request)
{
    $response = new Response();
    if(!$request->token_check){
        $response->error        = Common::error_true;
        $response->errorMessage = trans('messages.token_mismatch');
    }else{
        $messages = ['user_id.required' => trans('validation.required'),
          'user_id.numeric' => trans('validation.numeric')];

    $rules   = ['user_id'   => 'required|numeric'];
    $validator  = Validator::make($request->all(), $rules,$messages);
    if ($validator->fails()) {
     $data                   = $validator->messages();
     $response->error        = Common::error_true;
     $response->errorMessage = $data->first();
    }else{
        try{
            $data  = new DataService();
            $Setting_obj = new Setting();
            $Banner_obj = new Banner();
            $Users_obj = new Users();
            $user_id = $request->user_id;
            $user_record = $Users_obj->select("id","allow_notification","allow_music")->where("id",$user_id)->get()->toArray();
            $ringtone_record = $Setting_obj->where("meta_key","homeringtone")->first();

            $banner_record = $Banner_obj->select("*")->where("status","1")->get()->toArray();

            $banner_image = array();
            if(count($banner_record)>0)
            {
                foreach ($banner_record as $key => $value)
                {
                    $banner_image[] = url('public/upload/banner').'/'.$value["image"];
                }
            }
            if(count($user_record))
            {
                #$isExist["ringtone_record"] = url('public/upload/home').'/'.$ringtone_record["meta_value"];
                $data->error = Common::error_false;
                $data->errorMessage = trans('messages.sucess');
                $data->ringtone_record  = url('public/upload/home').'/'.$ringtone_record["meta_value"];
                $data->banner_record  = $banner_image;
                $data->user_record  = $user_record[0];
            }else{
                $data->error         = Common::error_true;
                $data->errorMessage  = trans('messages.invalidUser');
            }
        }catch(\Illuminate\Database\QueryException $ex){
            $jsonresp=$ex->getMessage();
            DB::rollBack();
            $data->error   = false;
        }
        $response = $data;
    }
    }
    $responsedata = Defaults::encode($response);
    return $responsedata;
}

public function registration(Request $request)
{
#echo "hello";die;
$response   = new Response();
$rules      = [
'firstname' => 'required|min:2|regex:/^[\pL\s\-]+$/u',
    'lastname' => 'required|min:2|regex:/^[\pL\s\-]+$/u',
    'email'=> 'required|email|regex:/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix|unique:users',
    'password'    => 'required|min:4',
    'telephone'   => 'required|numeric|digits_between:7,15|unique:users',
    'confirmpassword'    => 'required|same:password'
  ];

$validator  = Validator::make($request->all(), $rules);

if ($validator->fails()) { 
#print_r($validator->errors());die;
    $data                   = $validator->messages();
    $response->error        = Common::error_true;
    $response->errorMessage = $data->first();
} else {
$data   = new DataService();
	try{
		 #echo "hello";die;
    $firstname = $request->firstname;
    $lastname = $request->lastname;
    $telephone = $request->telephone;
    $email    = $request->email;
    $password =md5($request->password);
    
    $insert_data = array(
  	"firstname" => $firstname,
            "lastname" => $lastname,
            "telephone" => $telephone,
        "email" => $email,
 		"password" => $password
);
    //print_r($insert_data);die;
    $user_obj = new Users($insert_data);
$user_obj->save();
    //    dd(DB::getQueryLog());
       # echo "hello";die;
$user_id = $user_obj->id;
  //$status = $textMessage->sendMessage($messageData);
  /**********************/

   /* Send welcome mail at registered mail id*/
   $objDemo = new \stdClass();
   $objDemo->sender = 'TNT';
   $objDemo->invoice_file = '';
   $objDemo->receiver = ucwords($firstname." ".$lastname);
   $objDemo->from = env( 'MAIL_USERNAME' );
   $objDemo->subject = trans('messages.Welcome to TNT');
   $objDemo->message = trans('messages.Welcome to TNT. Thank you to connect with us');
   $objDemo->view_file = 'emailtemplate.welcome_mail';
   Mail::to($email)->send(new DemoEmail($objDemo));
   /**************/

 	$data  = new DataService();
 	if (!empty($user_id))
 	{
           
 		$data->error         = Common::error_false;
     $data->errorMessage  = trans('messages.sucess');
  }else{
 		$data->error        = Common::error_true;
     $data->errorMessage = trans('messages.query');
 	}
 	$response = $data;

//print_r($response);die;
	}catch(\Illuminate\Database\QueryException $ex){
    $jsonresp=$ex->getMessage();
    DB::rollBack();
    $data->error   = false;
	}
	DB::commit();
	
}
$responsedata = Defaults::encode($response);
return $responsedata;
}

public function login(Request $request)
{
$response = new Response();
$rules   = ['email'   => 'required|email',
            'password' =>'required'];
$validator  = Validator::make($request->all(), $rules);
if ($validator->fails()) {
    $data                   = $validator->messages();
    $response->error        = Common::error_true;
    $response->errorMessage = $data->first();
} else {
    $email = $request->email;
    $password = md5($request->password);
    
    $user_obj = new Users();
$isExist = $user_obj->select("*")->where("email",$email)->where("password",$password)->first();
    
    #echo "<pre>";print_r($isExist);die;

    /*print_r($isExist);
    echo "break";
    print_r($x);
    die;*/
    $data   = new DataService();
    if($isExist)
    {
        /*echo $isExist["status"];
        print_r($isExist);die;*/
        if($isExist["emailverification"] == 0)
        {
            $data->error         = Common::error_true;
            $data->errorMessage  = trans('messages.email_not_verified');
        }else{
            if($isExist["status"] == 0)
            {
                $data->error         = Common::error_true;
                $data->errorMessage  = trans('messages.account_hold');
            }else if($isExist["status"] == 2)
            {
                $data->error         = Common::error_true;
                $data->errorMessage  = trans('messages.account_unaproved');                     
            }else if($isExist["status"] == 1)
            {
                $ar = array("deviceToken"=>$request->deviceToken);
                $user_obj->where("id",$isExist["id"])->update($ar);

                    $drivertoken_obj = new Usertoken();
                $token = Str::random(60).$isExist["email"].$isExist["password"].$isExist["id"];
                $hash_token = hash('sha256', $token);
                $token_record = $drivertoken_obj->select("id")->where('user_id',$isExist["id"])->first();
                $array_user = array(
                        "user_id" => $isExist["id"],
                        "token" => $hash_token
                );
                #print_r($token_record);die;
                if($token_record)
                {
                    //echo "ifff";
                    $drivertoken_obj = new Usertoken();
                    $response = $drivertoken_obj->where("id",$token_record["id"])->update($array_user);
                }else{
                    //echo "elseee";
                    $drivertoken_obj = new Usertoken($array_user);
                    $response = $drivertoken_obj->save();
                }
                //die;
                $data->error = Common::error_false;
                $data->errorMessage = trans('messages.isLogin');
                #$data->usersDetails  = drivers::select('*')->where('id',$isExist['id'])->first();
                $data->usersDetails  = $isExist;
                $data->token  = $hash_token;
            }else{
                $data->error         = Common::error_true;
                $data->errorMessage  = trans('messages.query');
            }
        }            
    }else{
        $data->error         = Common::error_true;
        $data->errorMessage  = trans('messages.login');
    }
    $response = $data;
}
    $responsedata = Defaults::encode($response);
    return $responsedata;
}
public function getProfile(request $request)
{
$response = new Response();
if(!$request->token_check){
    $response->error        = Common::error_true;
    $response->errorMessage = trans('messages.token_mismatch');
}else{
    $messages = ['user_id.required' => trans('validation.required'),
          'user_id.numeric' => trans('validation.numeric')];

    $rules   = ['user_id'   => 'required|numeric'];
    $validator  = Validator::make($request->all(), $rules,$messages);
    if ($validator->fails()) {
     $data                   = $validator->messages();
     $response->error        = Common::error_true;
     $response->errorMessage = $data->first();
    } else {
        $userId = $request->user_id;
        $isExist = Users::select('*')->where('id',$userId)->first();
        $data   = new DataService();
        if($isExist)
        {
            $isExist["fullimage"] = url('public/upload/usersprofile').'/'.$isExist["image"];
            $isExist["old_image"] = $isExist["image"];
            $data->error = Common::error_false;
            $data->errorMessage = trans('messages.sucess');
            $data->usersDetails  = $isExist;
        }else{
            $data->error         = Common::error_true;
            $data->errorMessage  = trans('messages.invalidUser');
        }
        $response = $data;
    }
}
$responsedata = Defaults::encode($response);
return $responsedata;
}
public function EditUserProfile(Request $request)
{
    #print_r($_FILES["image"]["size"]);die;
$response = new Response();
if(!$request->token_check){
    $response->error        = Common::error_true;
    $response->errorMessage = trans('messages.token_mismatch');
}else{
    $user_id = $request->user_id;
    
    $messages = ['user_id.required' => trans('validation.required'),
          'user_id.numeric' => trans('validation.numeric'),
          'firstname.required' =>trans('validation.required'),
          'email.required'    =>trans('validation.required'),
          'email.email'       =>trans('validation.email'),
          'email.unique'       =>trans('validation.unique'),
          ];
    if($_FILES["image"]["size"] > 0)
    {
        $rules   = [
            'user_id'   => 'required|numeric',
            'firstname'=>'required|min:2|regex:/^[\pL\s\-]+$/u',
            'lastname'=>'required|min:2|regex:/^[\pL\s\-]+$/u',
            'email'   => 'required|email|regex:/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix|unique:users,email,'.$user_id,
            'telephone'   => 'required|numeric|digits_between:7,15|unique:users,telephone,'.$user_id,
            //'country'   => 'required|regex:/^[\pL\s\-]+$/u',
            //'city'   => 'required|regex:/^[\pL\s\-]+$/u',
            //'address'   => 'required',
            "image" => "mimes:jpeg,jpg,png,gif"
        ];
    }else{
        $rules   = [
            'user_id'   => 'required|numeric',
            'firstname'=>'required|min:2|regex:/^[\pL\s\-]+$/u',
            'lastname'=>'required|min:2|regex:/^[\pL\s\-]+$/u',
            'email'   => 'required|email|regex:/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix|unique:users,email,'.$user_id,
            'telephone'   => 'required|numeric|digits_between:7,15|unique:users,telephone,'.$user_id,
            //'country'   => 'required|regex:/^[\pL\s\-]+$/u',
            //'city'   => 'required|regex:/^[\pL\s\-]+$/u',
           // 'address'   => 'required'
        ];
    }      
    
    $validator  = Validator::make($request->all(), $rules,$messages);
    if ($validator->fails()) {
     $data                   = $validator->messages();
     $response->error        = Common::error_true;
     $response->errorMessage = $data->first();
    } else {
        $data   = new DataService();
        try{

            if($_FILES["image"]["size"] > 0)
            {
                #echo "hello";die;
                $image = $request->file('image');
                //echo "<pre>";print_r($image);
                $random = substr(md5(mt_rand()), 0, 4);
                $file_name = $input['imagename'] = time().$random.'user'.'.'.$image->getClientOriginalExtension();
                $destinationPath = public_path('/upload/usersprofile');
                $image->move($destinationPath, $input['imagename']);
                //echo $input['imagename']."form submit";

                if(!empty($request->old_image))
                {
                    $old_image = $request->old_image;
                    $destinationPath = public_path('/upload/usersprofile');
                    $file_pointer = $destinationPath.'/'.$old_image;
                    if (file_exists($file_pointer))
                    {
                        unlink($destinationPath.'/'.$old_image);
                    }

                }
            }else{
                if(!empty($request->old_image))
                {
                    $file_name = $request->old_image;
                }else{
                    $file_name = "";
                }
            }

            $user_id = $request->user_id;
                $array_data = array(
                        "firstname" => $request->firstname,
                        "lastname" => $request->lastname,
                        "email" => $request->email,
                        //"address" => $request->address,
                        //"latitude" => $request->latitude,
                        //"longitude" => $request->longitude,
                        "telephone" => $request->telephone,
                        "image" => $file_name,
                );
                #print_r($array_data);die;
                $Users_obj = new Users();
                $query_response = $Users_obj->where("id",$request->user_id)->update($array_data);

                if($query_response == 1)
                {
                    $isExist = Users::select('*')->where('id',$request->user_id)->first();
                    $isExist["fullimage"] = url('public/upload/usersprofile').'/'.$isExist["image"];
                    $isExist["old_image"] = $isExist["image"];
                    

                    $data->error = Common::error_false;
                    $data->errorMessage = trans('messages.sucess');
                    $data->usersDetails = $isExist;
                }else{
                    $data->error         = Common::error_true;
                    $data->errorMessage  = trans('messages.query');
                }
            }catch(QueryException $ex){
            $jsonresp=$ex->getMessage();
            DB::rollBack();
            $data->error   = false;
        }
        
        $response = $data;
    }
}
$responsedata = Defaults::encode($response);
return $responsedata;
}
public function userForgotPassword(Request $request)
{
$Users_obj = new Users;
$response   = new Response();

$rules = [
        'email' => 'required|email'
  ];
$validator  = Validator::make($request->all(), $rules);
if ($validator->fails()){ 
    #print_r($validator->errors());die;
    $data                   = $validator->messages();
    $response->error        = Common::error_true;
    $response->errorMessage = $data->first();
}else{
        $data   = new DataService();
    try{
        $email = $request->email;
        $record = $Users_obj->select("id","firstname","lastname","email")->where("email",$email)->get()->toArray();
            if(count($record)>0)
            {
                $new_password = mt_rand(100000, 999999);
                $new_password_md = md5($new_password);
                $Users_obj->where("email",$email)->update(["password"=>$new_password_md]);

                /* Send password on mail at registered mail id*/
               $objDemo = new \stdClass();
               $objDemo->sender = 'TNT';
               $objDemo->invoice_file = '';
               $objDemo->receiver = $record[0]["firstname"]." ".$record[0]["lastname"];
               $objDemo->password = $new_password;
               $objDemo->from = env( 'MAIL_USERNAME' );
               $objDemo->subject = trans('messages.Forgot password from TNT');
               $objDemo->message = "forgot_password_message";
               $objDemo->view_file = 'emailtemplate.user_forget_password';
               Mail::to($request->email)->send(new DemoEmail($objDemo));
                /**************/
    
                $data->error         = Common::error_false;
                $data->errorMessage  = trans('messages.sucess');
                #$data->record         = $record[0];
            }else{
                $data->error        = Common::error_true;
            $data->errorMessage = trans('messages.no_record');
            }
        }catch(QueryException $ex){
          $jsonresp=$ex->getMessage();
          DB::rollBack();
          $data->error   = $jsonresp;
        }
        $response = $data;
    }
DB::commit();
$responsedata = Defaults::encode($response);
return $responsedata;
}
public function uploadGallery(Request $request)
{
    /*print_r($_FILES);
print_r($request->all());die;*/
    /*for ($i=1; $i <=10; $i++)
    { 
        $iii = "image$i";
        if($_FILES["image$i"]["size"] > 0)
        {
            echo "if";
            echo $ext_var = $_FILES["image$i"]["name"];
        }else{
            echo "else$i";
        }

    }
    die;*/
$response = new Response();
if(!$request->token_check){
    $response->error        = Common::error_true;
    $response->errorMessage = trans('messages.token_mismatch');
}else{
    
    $rules   = [
        'user_id'   => 'required|numeric',
        'title'   => 'required|regex:/^[\w]+([-_\s]{1}[a-z0-9]+)*$/i',
        "image1" => "required"
    ];
    $validator  = Validator::make($request->all(), $rules);
    if ($validator->fails()) {
     $data                   = $validator->messages();
     $response->error        = Common::error_true;
     $response->errorMessage = $data->first();
    } else {
        $data   = new DataService();
        try{
            
            /*$data->error         = Common::error_true;
            $data->errorMessage  = trans('messages.event is over');
            $data->file  = $_FILES;
            $response = $data;
            $responsedata = Defaults::encode($response);
            return $responsedata;
                    die;*/
            $user_id = $request->user_id;
            $Event_attendance_obj = new Event_attendance();
            $event_attend = $Event_attendance_obj->select("event_id")->where("user_id",$user_id)->orderBy("id","desc")->first();
            $today_date = date('Y-m-d');
            $today_time = date('H:i');
            #echo $today_date.$today_time;
            #echo "<pre>";print_r($event_attend);die;
            if($event_attend)
            {
                $event_id = $event_attend["event_id"];
                $Events_obj = new Events();
                //SELECT * FROM `events` WHERE start_date = '2020-03-01' AND start_time <= '16:00' AND end_time >="16:00"
                $event_count = $Events_obj->where("id",$event_id)->where("start_date",$today_date)->where("start_time","<=",$today_time)->where("end_time",">=",$today_time)->count();
                //$gett = DB::getQueryLog();
                //print_r($gett);die;
                if($event_count >0)
                {
                    #echo "hello";die;
                    
                    if($_FILES["image1"]["size"] > 0)
                    {
                        $image_error = 0;
                        for ($i=1; $i <=1; $i++)
                        { 
                            if($_FILES["image$i"]["size"] > 0)
                            {
                                $ext_var = $_FILES["image$i"]["name"];
                                $explode_var = explode(".",$ext_var);
                                $extension = strtolower($explode_var[1]);
                                if($extension == "jpg" || $extension == "jpeg" || $extension == "gif" || $extension == "png" || $extension == "tif" || $extension == "mp4" || $extension == "mp3" || $extension == "ogg" || $extension == "wmv" || $extension == "webm" || $extension == "flv" || $extension == "avi")
                                {
                                    $image_error = 0;
                                }else{
                                    $image_error = 1;
                                }
                            }
                        }
                        
                        if($image_error == 1)
                        {
                            $data->error         = Common::error_true;
                            $data->errorMessage  = trans('messages.image_type_error');
                        }else{
                            $file_name = array();
                            for ($i=1; $i <=1; $i++)
                            {
                                if($_FILES["image$i"]["size"] > 0)
                                {
                                    $ext_var = $_FILES["image$i"]["name"];
                                    $image = $request->file('image$i');
                                    $explode_var = explode(".",$ext_var);
                                    #print_r($explode_var);die;
                                    $extension = strtolower($explode_var[1]);
                                    $image = $_FILES["image$i"]["name"];
                                    $random = substr(md5(mt_rand()), 0, 4);
                                    $file_name[] = $input['imagename'] = time().$random.$user_id.'.'.$extension;
                                    #echo 
                                    $destinationPath = public_path('/upload/gallery');
                                    //$image->move($destinationPath, $input['imagename']);
                                    move_uploaded_file($_FILES["image$i"]["tmp_name"], $destinationPath."/".$input['imagename']);

                                
                                }
                            }
                            
                            
                            if($request->upload == 1)
                            {
                                /*$data->error         = Common::error_true;
                                //$data->errorMessage  = trans('messages.event is over');
                                //$data->file  = $file_name[0];
                                $data->request  = $_FILES;
                                $response = $data;
                                
                                $responsedata = Defaults::encode($response);
                                return $responsedata;
                                die;*/
                                #print_r($file_name);
                              for ($y=0; $y <count($file_name); $y++)
                              { 

                                #echo $file_name[$y];die;
                                
                                //echo $file_name[$y];
                                //echo public_path('/download.jpg');
                                
                                $img11 = Image::make(public_path('/upload/gallery'.'/'.$file_name[$y]));
                                $img11->insert(public_path('/download.jpg'), 'bottom-right', 10, 10);
                                $img11->save(public_path('/upload/gallery'.'/'.$file_name[$y])); 
                                //$img11->save(public_path('/upload/gallery/'.$img11)); 
                                //echo 'Suces';die;
                              }
                              #print_r($file_name);die;
                              /*$data->error         = Common::error_true;
                                $data->errorMessage  = trans('messages.event is over');
                                $data->file  = $file_name[0];
                                $data->request  = $request->all();
                                $response = $data;
                                
                                $responsedata = Defaults::encode($response);
                                return $responsedata;
                                die;*/
                              
                            }
                            /*$data->error         = Common::error_true;
                                $data->errorMessage  = trans('messages.event is over');
                                $data->file  = $_FILES;
                                $response = $data;
                                $responsedata = Defaults::encode($response);
                                return $responsedata;
                            die;*/
                             #echo "hello";die;
                            #echo "<pre>";print_r($file_name);die;
                            $image = implode(",", $file_name);
                            //echo $input['imagename']."form submit";
                                $insert_data = array(
                                    "image" => $image,
                                    "event_id" => $event_id,
                                    "title" => $request->title,
                                    "upload" => $request->upload,
                                    "user_id" => $request->user_id,
                                    "status" => 1,
                                );
                                $Gallery_obj = new Gallery($insert_data);
                                $query_response = $Gallery_obj->save();
                            if($query_response == 1)
                            {
                                $data->error = Common::error_false;
                                $data->errorMessage = trans('messages.sucess');
                            }else{
                                $data->error         = Common::error_true;
                                $data->errorMessage  = trans('messages.query');
                            }
                        }
                    }else{
                        #echo "else";die;
                        $data->error         = Common::error_true;
                        $data->errorMessage  = trans('messages.Image is required');
                    }
                }else{
                    $data->error         = Common::error_true;
                    $data->errorMessage  = trans('messages.event is over');
                    //event is over
                }
            }else{
                $data->error         = Common::error_true;
                $data->errorMessage  = trans('messages.No event going on');
                //No event going on
            }
                                    
            }catch(QueryException $ex){
            $jsonresp=$ex->getMessage();
            DB::rollBack();
            $data->error   = false;
        }
        
        $response = $data;
    }
}
$responsedata = Defaults::encode($response);
return $responsedata;
}    
public function getGallery(Request $request)
{

$response = new Response();
if(!$request->token_check){
    $response->error        = Common::error_true;
    $response->errorMessage = trans('messages.token_mismatch');
}else{
    
    $rules   = [
        #'user_id'   => 'required|numeric',
        #'event_id'   => 'required|numeric',
    ];
    $validator  = Validator::make($request->all(), $rules);
    if ($validator->fails()) {
     $data                   = $validator->messages();
     $response->error        = Common::error_true;
     $response->errorMessage = $data->first();
    } else {
        $data   = new DataService();
        try{
            $user_id = $request->user_id;
            //$event_id = $request->event_id;
            $Gallery_obj = new Gallery();
            $isExist = $Gallery_obj->select("galleries.*")->where("parent_id",0)->where("status",1)->orderby("id","DESC")->get()->toArray();

            

            if(count($isExist)>0)
            {

                $y=0;
                $all_image = array();
                foreach ($isExist as $key => $value)
                {
                    $cccc_image = $Gallery_obj->where("parent_id",$value["id"])->where("status",1)->where("upload",1)->count();
                    $cccc_video = $Gallery_obj->where("parent_id",$value["id"])->where("status",1)->where("upload",2)->count();
                    if($value["upload"] == 1)
                    {
                        $cccc_image = $cccc_image +1;
                    }
                    if($value["upload"] == 2)
                    {
                        $cccc_video = $cccc_video +1;
                    }
                    $isExist[$y]["image_count"] = $cccc_image;
                    $isExist[$y]["video_count"] = $cccc_video;
                    $isExist[$y]["image"] = url("public/upload/gallery")."/".$value["image"];
                        
                    $isExist[$y]["date"] = strftime("%d %B, %Y",strtotime($value["created_at"]));
                    #$isExist[$y]["date"] = date("d/m/Y",strtotime($value["created_at"]));
                    $y++;
                }
                $data->error         = Common::error_false;
                $data->errorMessage = trans('messages.sucess');
                $data->record  = $isExist;
                //$data->all_image  = $all_image;
            }else{
                $data->error         = Common::error_true;
                $data->errorMessage  = trans('messages.no_record');
            }
        }catch(QueryException $ex){
            $jsonresp=$ex->getMessage();
            DB::rollBack();
            $data->error   = false;
        }
        
        $response = $data;
    }
}
$responsedata = Defaults::encode($response);
return $responsedata;
}   

  
public function getGalleryAllImageEvent(Request $request)
{

$response = new Response();
if(!$request->token_check){
    $response->error        = Common::error_true;
    $response->errorMessage = trans('messages.token_mismatch');
}else{
    
    $rules   = [
        'gallery_id'   => 'required|numeric|exists:galleries,id',
    ];
    $validator  = Validator::make($request->all(), $rules);
    if ($validator->fails()) {
     $data                   = $validator->messages();
     $response->error        = Common::error_true;
     $response->errorMessage = $data->first();
    } else {
        $data   = new DataService();
        try{
            $record = array();
            $gallery_id = $request->gallery_id;
            $Gallery_obj = new Gallery();
            $isExist = $Gallery_obj->where("parent_id",0)->where("upload",1)->where("status",1)->where("id",$gallery_id)->get()->toArray();
            $isExist2 = $Gallery_obj->where("parent_id",$gallery_id)->where("status",1)->where("upload",1)->get()->toArray();
            $record = array_merge($isExist,$isExist2);
            $record = array_values($record);
            #print_r($record);die;
            if(count($record)>0)
            {
                $y=0;
                $all_image = array();
                foreach ($record as $key => $value)
                {
                    $record[$y]["image"] = url("public/upload/gallery")."/".$value["image"];
                    $record[$y]["date"] = strftime("%d %B, %Y",strtotime($value["created_at"]));
                    #$record[$y]["date"] = date("d/m/Y",strtotime($value["created_at"]));
                    $y++;
                }
                #print_r($all_image);die;
                #$isExist[0]["all_image"] = $all_image;
                $data->error         = Common::error_false;
                $data->errorMessage = trans('messages.sucess');
                $data->usersDetails  = $record;
                #$data->all_image  = $all_image;
            }else{
                $data->error         = Common::error_true;
                $data->errorMessage  = trans('messages.no_record');
            }
        }catch(QueryException $ex){
            $jsonresp=$ex->getMessage();
            DB::rollBack();
            $data->error   = false;
        }
        
        $response = $data;
    }
}
$responsedata = Defaults::encode($response);
return $responsedata;
}


    
public function getGalleryVideo(Request $request)
{


$response = new Response();
if(!$request->token_check){
    $response->error        = Common::error_true;
    $response->errorMessage = trans('messages.token_mismatch');
}else{
    
    $rules   = [
        'gallery_id'   => 'required|numeric|exists:galleries,id',
    ];
    $validator  = Validator::make($request->all(), $rules);
    if ($validator->fails()) {
     $data                   = $validator->messages();
     $response->error        = Common::error_true;
     $response->errorMessage = $data->first();
    } else {
        $data   = new DataService();
        try{
            $record = array();
            $gallery_id = $request->gallery_id;
            $Gallery_obj = new Gallery();
            $isExist = $Gallery_obj->where("parent_id",0)->where("upload",2)->where("status",1)->where("id",$gallery_id)->get()->toArray();
            $isExist2 = $Gallery_obj->where("parent_id",$gallery_id)->where("status",1)->where("upload",2)->get()->toArray();
            $record = array_merge($isExist,$isExist2);
            $record = array_values($record);
            #print_r($record);die;
            if(count($record)>0)
            {
                $y=0;
                $all_image = array();
                foreach ($record as $key => $value)
                {
                    $record[$y]["image"] = url("public/upload/gallery")."/".$value["image"];
                    $record[$y]["date"] = strftime("%d %B, %Y",strtotime($value["created_at"]));
                    #$record[$y]["date"] = date("d/m/Y",strtotime($value["created_at"]));
                    $y++;
                }
                #print_r($all_image);die;
                #$isExist[0]["all_image"] = $all_image;
                $data->error         = Common::error_false;
                $data->errorMessage = trans('messages.sucess');
                $data->usersDetails  = $record;
                #$data->all_image  = $all_image;
            }else{
                $data->error         = Common::error_true;
                $data->errorMessage  = trans('messages.no_record');
            }
        }catch(QueryException $ex){
            $jsonresp=$ex->getMessage();
            DB::rollBack();
            $data->error   = false;
        }
        
        $response = $data;
    }
}
$responsedata = Defaults::encode($response);
return $responsedata;

}   

  
public function getGalleryAllImageEventVideo(Request $request)
{

$response = new Response();
if(!$request->token_check){
    $response->error        = Common::error_true;
    $response->errorMessage = trans('messages.token_mismatch');
}else{
    
    $rules   = [
        'event_id'   => 'required|numeric',
    ];
    $validator  = Validator::make($request->all(), $rules);
    if ($validator->fails()) {
     $data                   = $validator->messages();
     $response->error        = Common::error_true;
     $response->errorMessage = $data->first();
    } else {
        $data   = new DataService();
        try{
            $event_id = $request->event_id;
            $Gallery_obj = new Gallery();
            $isExist = $Gallery_obj->where("status",1)->where("galleries.upload",2)->where("event_id",$event_id)->get()->toArray();
            if(count($isExist)>0)
            {
                $y=0;
                $all_image = array();
                foreach ($isExist as $key => $value)
                {
                    $ext = explode(",", $value["image"]);
                    if(count($ext)>0)
                    {
                        for($x=0; $x<count($ext); $x++)
                        {
                            $all_image[]["image"] = url("public/upload/gallery")."/".$ext[$x];
                        }
                    }
                    $isExist[$y]["date"] = strftime("%d %B, %Y",strtotime($value["created_at"]));
                    $y++;
                }
                #print_r($all_image);die;
                #$isExist[0]["all_image"] = $all_image;
                $data->error         = Common::error_false;
                $data->errorMessage = trans('messages.sucess');
                $data->usersDetails  = $isExist;
                $data->all_image  = $all_image;
            }else{
                $data->error         = Common::error_true;
                $data->errorMessage  = trans('messages.no_record');
            }
        }catch(QueryException $ex){
            $jsonresp=$ex->getMessage();
            DB::rollBack();
            $data->error   = false;
        }
        
        $response = $data;
    }
}
$responsedata = Defaults::encode($response);
return $responsedata;
}
public function updateSettingNoti(Request $request)
{
$response = new Response();
if(!$request->token_check){
    $response->error        = Common::error_true;
    $response->errorMessage = trans('messages.token_mismatch');
}else{
    $user_id = $request->user_id;
    
    $messages = [
        'user_id.required' => trans('validation.required'),
          'user_id.numeric' => trans('validation.numeric'),
          'firstname.required' =>trans('validation.required'),
          'email.required'    =>trans('validation.required'),
          'email.email'       =>trans('validation.email'),
          'email.unique'       =>trans('validation.unique'),
          ];

    $rules   = [
        'user_id'   => 'required|numeric',
        'allow_notification'   => 'required|numeric',
        'allow_music'   => 'required|numeric',
        
    ];
    $validator  = Validator::make($request->all(), $rules,$messages);
    if ($validator->fails()) {
     $data                   = $validator->messages();
     $response->error        = Common::error_true;
     $response->errorMessage = $data->first();
    } else {
        $data   = new DataService();
        try{

            $user_id = $request->user_id;
                $array_data = array(
                        "allow_notification" => $request->allow_notification,
                        "allow_music" => $request->allow_music,
                );
                #print_r($array_data);die;
                $Users_obj = new Users();
                $query_response = $Users_obj->where("id",$request->user_id)->update($array_data);

                if($query_response == 1)
                {
                    $isExist = Users::select('*')->where('id',$request->user_id)->first();
                    $isExist["fullimage"] = url('public/upload/usersprofile').'/'.$isExist["image"];
                    $isExist["old_image"] = $isExist["image"];
                    $data->error = Common::error_false;
                    $data->errorMessage = trans('messages.sucess');
                    $data->usersDetails = $isExist;
                }else{
                    $data->error         = Common::error_true;
                    $data->errorMessage  = trans('messages.query');
                }
            }catch(QueryException $ex){
            $jsonresp=$ex->getMessage();
            DB::rollBack();
            $data->error   = false;
        }
        
        $response = $data;
    }
}
$responsedata = Defaults::encode($response);
return $responsedata;
}
public function generateQRcode(Request $request)
{
$response = new Response();
if(!$request->token_check){
    $response->error        = Common::error_true;
    $response->errorMessage = trans('messages.token_mismatch');
}else{
    $user_id = $request->user_id;
    
    $rules   = [
        'user_id'   => 'required|numeric'
        
    ];
    $validator  = Validator::make($request->all(), $rules);
    if ($validator->fails()) {
     $data                   = $validator->messages();
     $response->error        = Common::error_true;
     $response->errorMessage = $data->first();
    } else {
        $data   = new DataService();
        try{

            $user_id = $request->user_id;
            $str_result = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'.$user_id.time(); 
            $qr_code = substr(str_shuffle($str_result),0, 8); 
            #echo $qr_code."<br>";
            $response = $this->check_qr_code($qr_code,$user_id);
            #echo $qr_code."<br>";
            if($response > 0)
            {
                $response = $this->check_qr_code($qr_code,$user_id);
                #echo "if";
            }else{
                #echo "else".$qr_code."<br>";die;
                $Users_obj = new Users();
                $user_record = $Users_obj->select("qr_code")->where("id",$user_id)->get()->toArray();
                #print_r($user_record);die;
                if(count($user_record)>0)
                {
                    if(empty($user_record[0]["qr_code"]))
                    {
                        $array_data = array(
                            "qr_code" => $qr_code
                        );
                        #print_r($array_data);die;
                        $query_response = $Users_obj->where("id",$user_id)->update($array_data);
                    }else{
                        $query_response = 1;
                    }                            
                    if($query_response == 1)
                    {
                        $user_record = $Users_obj->select("qr_code","total_points")->where("id",$user_id)->get()->toArray();
                        $data->qr_code = $user_record[0]["qr_code"];
                        $data->error = Common::error_false;
                        $data->errorMessage = trans('messages.sucess');
                        $data->total_points = $user_record[0]["total_points"];
                    }else{
                        $data->error         = Common::error_true;
                        $data->errorMessage  = trans('messages.query');
                    }
                }else{
                    $data->error         = Common::error_true;
                    $data->errorMessage  = trans('messages.no_record');
                }                        
            }
            }catch(QueryException $ex){
            $jsonresp=$ex->getMessage();
            DB::rollBack();
            $data->error   = false;
        }
        
        $response = $data;
    }
}
$responsedata = Defaults::encode($response);
return $responsedata;
}
public function check_qr_code($str_result)
{
$user_obj = new Users();
$count = $user_obj->where("qr_code",$str_result)->count();
return $count;
}
public function allEvents(Request $request)
{

$response = new Response();
if(!$request->token_check){
    $response->error        = Common::error_true;
    $response->errorMessage = trans('messages.token_mismatch');
}else{
   $data   = new DataService();

   try{
      #print_r($request->all());die;
        if(empty($request->start_date))
        {
            $start_date = date("Y-m-d");
        }else{
            $start_date = str_replace("/","-",$request->start_date);
            $start_date = date("Y-m-d",strtotime($start_date));
        }
      $club_name = $request->club_name;
       $Events_obj = new Events();
       $query = $Events_obj->select("events.*","clubs.club_name");
                 $query->join("clubs","events.club_id","clubs.id");
                 if(!empty($start_date))
                 {
                   $query->where("events.start_date",'>=',$start_date);
                 }
                 if(!empty($club_name))
                 {
                   $query->where("clubs.club_name","like","%".$club_name."%");
                 }
                 $query->where("events.status","1");
                 $query->orderBy("events.id","desc");
                 $record = $query->get()->toArray();
       //$gett = DB::getQueryLog();
       //print_r($gett);die;          
       if(count($record)>0)
       {
         $x=0;
         foreach ($record as $key => $value)
         {
           $ext = explode(",", $value["image"]);
           $record[$x]["fullimage"] = url("public/upload/events")."/".$ext[0];
           #setlocale(LC_TIME, "fr_FR"); 
           $record[$x]["start_date"] = strftime("%d %B, %Y",strtotime($value["start_date"]));
           $x++;
         }
         $data->error         = Common::error_false;
         $data->errorMessage = trans('messages.sucess');
         $data->record = $record;
       }else{
           $data->error         = Common::error_true;
           $data->errorMessage  = trans('messages.no_record');
       }
   }catch(QueryException $ex){
       $jsonresp=$ex->getMessage();
       DB::rollBack();
       $data->error   = false;
   }
   
   $response = $data;
    
}
$responsedata = Defaults::encode($response);
return $responsedata;



}
public function singleEvents(Request $request)
{

$response = new Response();
if(!$request->token_check){
    $response->error        = Common::error_true;
    $response->errorMessage = trans('messages.token_mismatch');
}else{
   $data   = new DataService();
   $rules   = ['id'   => 'required|numeric'];
$validator  = Validator::make($request->all(), $rules);
if ($validator->fails()) {
 #echo "if";die;
    $data                   = $validator->messages();
    $response->error        = Common::error_true;
    $response->errorMessage = $data->first();
} else {
   try{
      #print_r($request->all());die;
      $id = $request->id;
       $Events_obj = new Events();
       $query = $Events_obj->select("events.*","clubs.club_name","clubs.address","clubs.latitude","clubs.longitude");
                 $query->join("clubs","events.club_id","clubs.id");
                 $query->where("events.id","=",$id);
                 $query->where("events.status","1");
                 $record = $query->get()->toArray();
       #$gett = DB::getQueryLog();
       #print_r($gett);die;          
       if(count($record)>0)
       {
         $x=0;
         $array_image = array();
         foreach ($record as $key => $value)
         {
           $ext = explode(",", $value["image"]);
           for($y=0; $y<count($ext); $y++)
           {
             $array_image[$y] = url("public/upload/events")."/".$ext[$y];
           }
           #$record[$x]["fullimage"] = 
           #setlocale(LC_TIME, "fr_FR"); 
           $record[$x]["array_image"] = $array_image;
           $x++;
         }
         #print_r($array_image);die;
         $data->error         = Common::error_false;
         $data->errorMessage = trans('messages.sucess');
         $data->record = $record[0];
       }else{
           $data->error         = Common::error_true;
           $data->errorMessage  = trans('messages.no_record');
       }
   }catch(QueryException $ex){
       $jsonresp=$ex->getMessage();
       DB::rollBack();
       $data->error   = false;
   }

   $response = $data;
}
    
}
$responsedata = Defaults::encode($response);
return $responsedata;



}
public function allNews(Request $request)
{
    //get_record_all()

$request->token_check = 1;
$response = new Response();
if(!$request->token_check){
    $response->error        = Common::error_true;
    $response->errorMessage = trans('messages.token_mismatch');
}else{
   $data   = new DataService();

   try{
      #print_r($request->all());die;
        $NewsModel_obj = new NewsModel();
        $record = $NewsModel_obj->get_record_all();
       #$gett = DB::getQueryLog();
       #print_r($record);die;          
       if(count($record)>0)
       {
        $x=0;
         foreach ($record as $key => $value)
         {
            $record[$x]["text"] = strip_tags($value["text"]);
            $record[$x]["date"] = strftime("%d %B, %Y",strtotime($value["created_at"]));
            $x++;
         }
         $data->error         = Common::error_false;
         $data->errorMessage = trans('messages.sucess');
         $data->record = $record;
       }else{
           $data->error         = Common::error_true;
           $data->errorMessage  = trans('messages.no_record');
       }
   }catch(QueryException $ex){
       $jsonresp=$ex->getMessage();
       DB::rollBack();
       $data->error   = false;
   }
   
   $response = $data;
    
}
$responsedata = Defaults::encode($response);
return $responsedata;

}

public function historyAllEvents(Request $request)
{

$response = new Response();
if(!$request->token_check){
    $response->error        = Common::error_true;
    $response->errorMessage = trans('messages.token_mismatch');
}else{
   $data   = new DataService();

   try{
      #print_r($request->all());die;
       // SELECT * FROM `events` WHERE start_date_time <= '2020-03-03 23:54'
      $start_date_time = date("Y-m-d H:i:s");
       $Events_obj = new Events();

       $Gallery_obj = new Gallery();
       $Gallery_obj->select("*")->groupBy("title")->orderby("id","DESC")->get()->toArray();
       

       //$gett = DB::getQueryLog();
       //print_r($gett);die;          
       if(count($record)>0)
       {
         $x=0;
         foreach ($record as $key => $value)
         {
           $ext = explode(",", $value["image"]);
           $record[$x]["fullimage"] = url("public/upload/events")."/".$ext[0];
           #setlocale(LC_TIME, "fr_FR"); 
           $record[$x]["start_date"] = strftime("%d %B, %Y",strtotime($value["start_date"]));
           $x++;
         }
         $data->error         = Common::error_false;
         $data->errorMessage = trans('messages.sucess');
         $data->record = $record;
       }else{
           $data->error         = Common::error_true;
           $data->errorMessage  = trans('messages.no_record');
       }
   }catch(QueryException $ex){
       $jsonresp=$ex->getMessage();
       DB::rollBack();
       $data->error   = false;
   }
   
   $response = $data;
    
}
}
public function getUserHistory(Request $request)
{

$response = new Response();
if(!$request->token_check){
    $response->error        = Common::error_true;
    $response->errorMessage = trans('messages.token_mismatch');
}else{
        $user_id = $request->user_id;
        
        $rules   = [
            'user_id'   => 'required|numeric|exists:users,id'
            
        ];
        $validator  = Validator::make($request->all(), $rules);
        if ($validator->fails()) {
         $data                   = $validator->messages();
         $response->error        = Common::error_true;
         $response->errorMessage = $data->first();
        } else {
            $data   = new DataService();
            try{
                $user_id = $request->user_id;
                $Event_attendance = new Event_attendance();
                $record = $Event_attendance->where("user_id",$user_id)->orderBy("id","DESC")->get()->toArray();

                   if(count($record)>0)
                   { $x=0;
                    foreach($record as $val)
                    {
                        $record[$x]["date"] = date("d/m/Y",strtotime($val["today_date"]));
                        $record[$x]["time"] = date("H:i",strtotime($val["today_date"]));
                        $x++;
                    }
                     $data->error         = Common::error_false;
                     $data->errorMessage = trans('messages.sucess');
                     $data->record = $record;
                   }else{
                       $data->error         = Common::error_true;
                       $data->errorMessage  = trans('messages.no_record');
                   }
                }catch(QueryException $ex){
                $jsonresp=$ex->getMessage();
                DB::rollBack();
                $data->error   = false;
            }
            
            $response = $data;
        }
    }
$responsedata = Defaults::encode($response);
return $responsedata;
}
public function TodayCurrentEvents(Request $request)
{
    $response = new Response();
    if(!$request->token_check){
        $response->error        = Common::error_true;
        $response->errorMessage = trans('messages.token_mismatch');
    }else{
       $data   = new DataService();

       try{
          #print_r($request->all());die;
           // SELECT * FROM `events` WHERE start_date_time <= '2020-03-03 23:54'
          $start_date_time = date("Y-m-d H:i:s");
           $Events_obj = new Events();
           $query = $Events_obj->select("events.*","clubs.club_name");
                     $query->join("clubs","events.club_id","clubs.id");
                     $query->where("events.start_date_time",">=",$start_date_time);
                     $query->where("events.status","1");
                     $query->orderBy("events.id","asc");
                     $record = $query->get()->toArray();
           //$gett = DB::getQueryLog();
           //print_r($gett);die;          
           if(count($record)>0)
           {
             $x=0;
             foreach ($record as $key => $value)
             {
               $ext = explode(",", $value["image"]);
               $record[$x]["fullimage"] = url("public/upload/events")."/".$ext[0];
               #setlocale(LC_TIME, "fr_FR"); 
               $record[$x]["start_date"] = strftime("%d %B, %Y",strtotime($value["start_date"]));
               $x++;
             }
             $data->error         = Common::error_false;
             $data->errorMessage = trans('messages.sucess');
             $data->record = $record;
           }else{
               $data->error         = Common::error_true;
               $data->errorMessage  = trans('messages.no_record');
           }
       }catch(QueryException $ex){
           $jsonresp=$ex->getMessage();
           DB::rollBack();
           $data->error   = false;
       }
       
       $response = $data;
        
    }
    $responsedata = Defaults::encode($response);
    return $responsedata;
}

public function historyUserEvents(Request $request)
{
    $response = new Response();
    if(!$request->token_check){
        $response->error        = Common::error_true;
        $response->errorMessage = trans('messages.token_mismatch');
    }else{
        $user_id = $request->user_id;
        
        $rules   = [
            'user_id'   => 'required|numeric'
            
        ];
        $validator  = Validator::make($request->all(), $rules);
        if ($validator->fails()) {
         $data                   = $validator->messages();
         $response->error        = Common::error_true;
         $response->errorMessage = $data->first();
        } else {
            $data   = new DataService();
            try{
                $user_id = $request->user_id;
                  #print_r($request->all());die;
                   // SELECT * FROM `events` WHERE start_date_time <= '2020-03-03 23:54'
                  $start_date_time = date("Y-m-d H:i:s");
                   $Events_obj = new Events();
                   $query = $Events_obj->select("events.*","clubs.club_name");
                             $query->join("clubs","events.club_id","clubs.id");
                             $query->join("event_attendance","events.id","event_attendance.event_id");
                             $query->where("events.start_date_time","<=",$start_date_time);
                             $query->where("event_attendance.user_id",$user_id);
                             $query->where("events.status","1");
                             $query->orderBy("events.id","asc");
                             $record = $query->get()->toArray();
                   //$gett = DB::getQueryLog();
                   //print_r($gett);die;          
                   if(count($record)>0)
                   {
                     $x=0;
                     foreach ($record as $key => $value)
                     {
                       $ext = explode(",", $value["image"]);
                       $record[$x]["fullimage"] = url("public/upload/events")."/".$ext[0];
                       #setlocale(LC_TIME, "fr_FR"); 
                       $record[$x]["start_date"] = strftime("%d %B, %Y",strtotime($value["start_date"]));
                       $x++;
                     }
                     $data->error         = Common::error_false;
                     $data->errorMessage = trans('messages.sucess');
                     $data->record = $record;
                   }else{
                       $data->error         = Common::error_true;
                       $data->errorMessage  = trans('messages.no_record');
                   }
                }catch(QueryException $ex){
                $jsonresp=$ex->getMessage();
                DB::rollBack();
                $data->error   = false;
            }
            
            $response = $data;
        }
    }
    $responsedata = Defaults::encode($response);
    return $responsedata;

}
public function clubList(Request $request)
{

$response = new Response();
if(!$request->token_check){
    $response->error        = Common::error_true;
    $response->errorMessage = trans('messages.token_mismatch');
}else{
   $data   = new DataService();

   try{
      #print_r($request->all());die;
       // SELECT * FROM `events` WHERE start_date_time <= '2020-03-03 23:54'
      $start_date_time = date("Y-m-d H:i:s");
       $Clubs_obj = new Clubs();
       $record = $Clubs_obj->where("status",1)->get()->toArray();
       //$gett = DB::getQueryLog();
       //print_r($gett);die;          
       if(count($record)>0)
       {
         $data->error         = Common::error_false;
         $data->errorMessage = trans('messages.sucess');
         $data->record = $record;
       }else{
           $data->error         = Common::error_true;
           $data->errorMessage  = trans('messages.no_record');
       }
   }catch(QueryException $ex){
       $jsonresp=$ex->getMessage();
       DB::rollBack();
       $data->error   = false;
   }
   
   $response = $data;
    
}
$responsedata = Defaults::encode($response);
return $responsedata;



}
    public function getInfo(Request $request)
    {
       $data   = new DataService();
       try{
          $Info_obj = new Info();
          $record = $Info_obj->where("id",1)->get()->toArray();        
           if(count($record)>0)
           {
             $data->error         = Common::error_false;
             $data->errorMessage = trans('messages.sucess');
             $data->record = $record;
           }else{
               $data->error         = Common::error_true;
               $data->errorMessage  = trans('messages.no_record');
           }
       }catch(QueryException $ex){
           $jsonresp=$ex->getMessage();
           DB::rollBack();
           $data->error   = false;
       }
       $response = $data;
        $responsedata = Defaults::encode($response);
        return $responsedata;
    }


}
