<?php

namespace App\Http\Controllers\api;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Response;
use App\Http\Utility\Common;
use App\Http\Service\DataService;
use App\Http\Utility\Defaults;
use Illuminate\Support\Str;
use Validator;
use App\Users;
use App\Usertoken;
use App\Managertoken;
use App\Gallery;
use App\Events;
use App\Managers;
use App\Event_attendance;
use App\Setting;
use DB;
use App\Mail\DemoEmail;
use Illuminate\Support\Facades\Mail;
use Intervention\Image\ImageManagerStatic as Image;

class ManagerController extends Controller
{
 public function __construct()
 {
   DB::enableQueryLog();
 }
public function managerRegistration(Request $request)
{
#echo "hello";die;
$response   = new Response();
$rules      = [
'firstname' => 'required|min:2|regex:/^[\pL\s\-]+$/u',
    'lastname' => 'required|min:2|regex:/^[\pL\s\-]+$/u',
    'email'=> 'required|email|regex:/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix|unique:managers',
    'password'    => 'required|min:4',
    'telephone'   => 'required|numeric|digits_between:7,15|unique:managers',
    'confirmpassword'    => 'required|same:password'
  ];

$validator  = Validator::make($request->all(), $rules);

if ($validator->fails()) { 
#print_r($validator->errors());die;
    $data                   = $validator->messages();
    $response->error        = Common::error_true;
    $response->errorMessage = $data->first();
} else {
$data   = new DataService();
	try{
		 #echo "hello";die;
    $firstname = $request->firstname;
    $lastname = $request->lastname;
    $email    = $request->email;
    $telephone    = $request->telephone;
    $password =md5($request->password);
    
    $insert_data = array(
  	"firstname" => $firstname,
            "lastname" => $lastname,
        "email" => $email,
        "telephone" => $telephone,
 		"password" => $password
);
    //print_r($insert_data);die;
    $user_obj = new Managers($insert_data);
$user_obj->save();
    //    dd(DB::getQueryLog());
       # echo "hello";die;
$user_id = $user_obj->id;
  //$status = $textMessage->sendMessage($messageData);
  /**********************/

   /* Send welcome mail at registered mail id*/
   $objDemo = new \stdClass();
   $objDemo->sender = 'TNT';
   $objDemo->invoice_file = '';
   $objDemo->receiver = ucwords($firstname." ".$lastname);
   $objDemo->from = env( 'MAIL_USERNAME' );
   $objDemo->subject = trans('messages.Welcome to TNT');
   $objDemo->message = trans('messages.Welcome to TNT. Thank you to connect with us');
   $objDemo->view_file = 'emailtemplate.welcome_mail';
   Mail::to($email)->send(new DemoEmail($objDemo));
   /**************/
   
 	$data  = new DataService();
 	if (!empty($user_id))
 	{
           
 		$data->error         = Common::error_false;
     $data->errorMessage  = trans('messages.sucess');
  }else{
 		$data->error        = Common::error_true;
     $data->errorMessage = trans('messages.query');
 	}
 	$response = $data;

//print_r($response);die;
	}catch(\Illuminate\Database\QueryException $ex){
    $jsonresp=$ex->getMessage();
    DB::rollBack();
    $data->error   = false;
	}
	DB::commit();
	
}
$responsedata = Defaults::encode($response);
return $responsedata;
}

public function login(Request $request)
{
$response = new Response();
$rules   = ['email'   => 'required|email',
            'password' =>'required'];
$validator  = Validator::make($request->all(), $rules);
if ($validator->fails()) {
    $data                   = $validator->messages();
    $response->error        = Common::error_true;
    $response->errorMessage = $data->first();
} else {
    $email = $request->email;
    $password = md5($request->password);
    
    $user_obj = new Managers();
$isExist = $user_obj->select("*")->where("email",$email)->where("password",$password)->first();
    
    #echo "<pre>";print_r($isExist);die;

    /*print_r($isExist);
    echo "break";
    print_r($x);
    die;*/
    $data   = new DataService();
    if($isExist)
    {
        /*echo $isExist["status"];
        print_r($isExist);die;*/
        
            if($isExist["status"] == 0)
            {
                $data->error         = Common::error_true;
                $data->errorMessage  = trans('messages.account_hold');
            }else if($isExist["status"] == 2)
            {
                $data->error         = Common::error_true;
                $data->errorMessage  = trans('messages.account_unaproved');                     
            }else if($isExist["status"] == 1)
            {
                $ar = array("deviceToken"=>$request->deviceToken);
                $user_obj->where("id",$isExist["id"])->update($ar);
                
                    $drivertoken_obj = new Managertoken();
                $token = Str::random(60).$isExist["email"].$isExist["password"].$isExist["id"];
                $hash_token = hash('sha256', $token);
                $token_record = $drivertoken_obj->select("id")->where('user_id',$isExist["id"])->first();
                $array_user = array(
                        "user_id" => $isExist["id"],
                        "token" => $hash_token
                );
                #print_r($token_record);die;
                if($token_record)
                {
                    //echo "ifff";
                    $drivertoken_obj = new Managertoken();
                    $response = $drivertoken_obj->where("id",$token_record["id"])->update($array_user);
                }else{
                    //echo "elseee";
                    $drivertoken_obj = new Managertoken($array_user);
                    $response = $drivertoken_obj->save();
                }
                //die;
                $data->error = Common::error_false;
                $data->errorMessage = trans('messages.isLogin');
                #$data->usersDetails  = drivers::select('*')->where('id',$isExist['id'])->first();
                $data->usersDetails  = $isExist;
                $data->token  = $hash_token;
            }else{
                $data->error         = Common::error_true;
                $data->errorMessage  = trans('messages.query');
            }
                   
    }else{
        $data->error         = Common::error_true;
        $data->errorMessage  = trans('messages.login');
    }
    $response = $data;
}
    $responsedata = Defaults::encode($response);
    return $responsedata;
}
public function managergetProfile(request $request)
{
    #echo "hello";die;
$response = new Response();
if(!$request->token_check){
    $response->error        = Common::error_true;
    $response->errorMessage = trans('messages.token_mismatch');
}else{
    $messages = ['user_id.required' => trans('validation.required'),
          'user_id.numeric' => trans('validation.numeric')];

    $rules   = ['user_id'   => 'required|numeric'];
    $validator  = Validator::make($request->all(), $rules,$messages);
    if ($validator->fails()) {
     $data                   = $validator->messages();
     $response->error        = Common::error_true;
     $response->errorMessage = $data->first();
    } else {
        $userId = $request->user_id;
        $isExist = Managers::select('*')->where('id',$userId)->first();
        $data   = new DataService();
        if($isExist)
        {
            $isExist["fullimage"] = url('public/upload/usersprofile').'/'.$isExist["image"];
            $isExist["old_image"] = $isExist["image"];
            $data->error = Common::error_false;
            $data->errorMessage = trans('messages.sucess');
            $data->usersDetails  = $isExist;
        }else{
            $data->error         = Common::error_true;
            $data->errorMessage  = trans('messages.invalidUser');
        }
        $response = $data;
    }
}
$responsedata = Defaults::encode($response);
return $responsedata;
}
public function managerEditUserProfile(Request $request)
{
$response = new Response();
if(!$request->token_check){
    $response->error        = Common::error_true;
    $response->errorMessage = trans('messages.token_mismatch');
}else{
    $user_id = $request->user_id;
    
    $messages = ['user_id.required' => trans('validation.required'),
          'user_id.numeric' => trans('validation.numeric'),
          'firstname.required' =>trans('validation.required'),
          'email.required'    =>trans('validation.required'),
          'email.email'       =>trans('validation.email'),
          'email.unique'       =>trans('validation.unique'),
          ];

    $rules   = [
        'user_id'   => 'required|numeric',
        //'firstname'=>'required|min:2|regex:/^[\pL\s\-]+$/u',
        //'lastname'=>'required|min:2|regex:/^[\pL\s\-]+$/u',
        'firstname'=>'required|min:2',
        'lastname'=>'required|min:2',
        'email'   => 'required|email|regex:/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix|unique:managers,email,'.$user_id,
        'telephone'   => 'required|numeric|digits_between:7,15|unique:managers,telephone,'.$user_id,
        //'address'   => 'required|regex:/^[\w]+([-_\s]{1}[a-z0-9]+)*$/i',
        #"image" => "mimes:jpeg,jpg,png,gif"
    ];
    $validator  = Validator::make($request->all(), $rules,$messages);
    if ($validator->fails()) {
     $data                   = $validator->messages();
     $response->error        = Common::error_true;
     $response->errorMessage = $data->first();
    } else {
        $data   = new DataService();
        try{

             if($_FILES["image"]["size"] > 0)
            {
                #echo "hello";die;
                $image = $request->file('image');
                //echo "<pre>";print_r($image);
                $random = substr(md5(mt_rand()), 0, 4);
                $file_name = $input['imagename'] = time().$random.'user'.'.'.$image->getClientOriginalExtension();
                $destinationPath = public_path('/upload/usersprofile');
                $image->move($destinationPath, $input['imagename']);
                //echo $input['imagename']."form submit";

                if(!empty($request->old_image))
                {
                    $old_image = $request->old_image;
                    $destinationPath = public_path('/upload/usersprofile');
                    $file_pointer = $destinationPath.'/'.$old_image;
                    if (file_exists($file_pointer))
                    {
                        unlink($destinationPath.'/'.$old_image);
                    }

                }
            }else{
                if(!empty($request->old_image))
                {
                    $file_name = $request->old_image;
                }else{
                    $file_name = "";
                }
            }

            $user_id = $request->user_id;
                $array_data = array(
                        "firstname" => $request->firstname,
                        "lastname" => $request->lastname,
                        "email" => $request->email,
                        //"address" => $request->address,
                        //"latitude" => $request->latitude,
                        //"longitude" => $request->longitude,
                        "telephone" => $request->telephone,
                        "image" => $file_name,
                );
                #print_r($array_data);die;
                $Users_obj = new Managers();
                $query_response = $Users_obj->where("id",$request->user_id)->update($array_data);

                if($query_response == 1)
                {
                    $isExist = Managers::select('*')->where('id',$request->user_id)->first();
                    $isExist["fullimage"] = url('public/upload/usersprofile').'/'.$isExist["image"];
                    $isExist["old_image"] = $isExist["image"];
                    

                    $data->error = Common::error_false;
                    $data->errorMessage = trans('messages.sucess');
                    $data->usersDetails = $isExist;
                }else{
                    $data->error         = Common::error_true;
                    $data->errorMessage  = trans('messages.query');
                }
            }catch(QueryException $ex){
            $jsonresp=$ex->getMessage();
            DB::rollBack();
            $data->error   = false;
        }
        
        $response = $data;
    }
}
$responsedata = Defaults::encode($response);
return $responsedata;
}
public function managerForgotPassword(Request $request)
{
$Users_obj = new Managers;
$response   = new Response();

$rules = [
        'email' => 'required|email'
  ];
$validator  = Validator::make($request->all(), $rules);
if ($validator->fails()){ 
    #print_r($validator->errors());die;
    $data                   = $validator->messages();
    $response->error        = Common::error_true;
    $response->errorMessage = $data->first();
}else{
        $data   = new DataService();
    try{
        $email = $request->email;
        $record = $Users_obj->select("id","firstname","lastname","email")->where("email",$email)->get()->toArray();
            if(count($record)>0)
            {
                $new_password = mt_rand(100000, 999999);
                $new_password_md = md5($new_password);
                $Users_obj->where("email",$email)->update(["password"=>$new_password_md]);

                /* Send password on mail at registered mail id*/
               $objDemo = new \stdClass();
               $objDemo->sender = 'TNT';
               $objDemo->invoice_file = '';
               $objDemo->receiver = $record[0]["firstname"]." ".$record[0]["lastname"];
               $objDemo->password = $new_password;
               $objDemo->from = env( 'MAIL_USERNAME' );
               $objDemo->subject = trans('messages.Forgot password from TNT');
               $objDemo->message = "forgot_password_message";
               $objDemo->view_file = 'emailtemplate.user_forget_password';
               Mail::to($request->email)->send(new DemoEmail($objDemo));
                /**************/
    
                $data->error         = Common::error_false;
                $data->errorMessage  = trans('messages.sucess');
                #$data->record         = $record[0];
            }else{
                $data->error        = Common::error_true;
                $data->errorMessage = trans('messages.no_record');
            }
        }catch(QueryException $ex){
          $jsonresp=$ex->getMessage();
          DB::rollBack();
          $data->error   = $jsonresp;
        }
        $response = $data;
    }
DB::commit();
$responsedata = Defaults::encode($response);
return $responsedata;
}
    public function scanQRcode(Request $request)
        {
            $response = new Response();
if(!$request->token_check){
    $response->error        = Common::error_true;
    $response->errorMessage = trans('messages.token_mismatch');
}else{
    #echo "<pre>";print_r($request->all());die;
            $Users_obj = new Users;
        $response   = new Response();

        $rules = [
                #'event_id' => 'required',
                'id' => 'required',
                'manager_id' => 'required',
          ];
        $validator  = Validator::make($request->all(), $rules);
        if ($validator->fails()){ 
            #print_r($validator->errors());die;
            $data                   = $validator->messages();
            $response->error        = Common::error_true;
            $response->errorMessage = $data->first();
        }else{
                $data   = new DataService();
            try{
                $manager_id = $request->manager_id;
                $id = $request->id;
                $response_query = $Users_obj->where("qr_code",$id)->count();
                #echo $response;
                if($response_query > 0)
                {
                    $user_record = $Users_obj->select("id","total_points")->where("qr_code",$id)->first();
                    #print_r($user_record);die;
                    $Events_obj = new Events();
                    $Setting_obj = new Setting();
                    $setting_rec = $Setting_obj->where("id",2)->get()->toArray();
                    /*$event_record = $Events_obj->select("points")->where("id",$request->event_id)->first();*/
                    if(count($setting_rec)>0)
                    {
                        $points = $setting_rec[0]["meta_value"];
                    }else{
                        $points = 10;
                    }
                    $total_points = $user_record["total_points"] + $points;
                    $update_array = array(
                        "total_points" => $total_points
                    );
                    
                    $today_date = date("Y-m-d H:i:s");
                    $today_dates = date("Y-m-d");
                    $array_data = array(
                         #"event_id" => $request->event_id, 
                         "user_id" => $user_record["id"], 
                         "today_date" => $today_date, 
                         "today_dates" => $today_dates, 
                         "manager_id" => $manager_id, 
                         "points" => $points, 
                    );
                    #print_r($array_data);die;
                    #$Event_attendance = new Event_attendance();
                    #$count_enter = $Event_attendance->where($array_data)->count();
                    $count_enter = 0;
                    if($count_enter > 0 )
                    {
                        $data->error        = Common::error_true;
                        $data->errorMessage = trans('messages.all_ready_earned_point_for_this_event');
                    }else{
                        $Users_obj->where("id",$user_record["id"])->update($update_array);
                        $Event_attendance = new Event_attendance($array_data);
                        $response_query_up = $Event_attendance->save();
                        if($response_query_up == 1)
                        {
                            $data->error        = Common::error_false;
                            $data->errorMessage = trans('messages.Thank you for coming');
                        }else{
                            $data->error        = Common::error_true;
                            $data->errorMessage = trans('messages.query');
                        }
                    }
                    
                    
                }else{
                    $data->error        = Common::error_true;
                    $data->errorMessage = trans('messages.This QR code is not match');
                }
            }catch(QueryException $ex){
                  $jsonresp=$ex->getMessage();
                  DB::rollBack();
                  $data->error   = $jsonresp;
                }
                $response = $data;
            }
        DB::commit();
}
        $responsedata = Defaults::encode($response);
        return $responsedata;
    }

    public function TodayallEvents(Request $request)
    {
        $request->token_check = 1;
        $response = new Response();
        if(!$request->token_check){
            $response->error        = Common::error_true;
            $response->errorMessage = trans('messages.token_mismatch');
        }else{
           $data   = new DataService();
           try{
              #print_r($request->all());die;
              $start_date = date("Y-m-d");
              $club_name = $request->club_name;
               $Events_obj = new Events();
               $query = $Events_obj->select("events.*","clubs.club_name");
                        $query->join("clubs","events.club_id","clubs.id");
                        $query->where("events.start_date",$start_date);
                        $query->orderBy("events.id","desc");
                        $record = $query->get()->toArray();
               #$gett = DB::getQueryLog();
               #print_r($gett);die;          
               if(count($record)>0)
               {
                 $x=0;
                 foreach ($record as $key => $value)
                 {
                   $ext = explode(",", $value["image"]);
                   $record[$x]["fullimage"] = url("public/upload/events")."/".$ext[0];
                   #setlocale(LC_TIME, "fr_FR"); 
                   $record[$x]["start_date"] = strftime("%d %B, %Y",strtotime($value["start_date"]));
                   $x++;
                 }
                 $data->error         = Common::error_false;
                 $data->errorMessage = trans('messages.sucess');
                 $data->record = $record;
               }else{
                   $data->error         = Common::error_true;
                   $data->errorMessage  = trans('messages.no_record');
               }
           }catch(QueryException $ex){
               $jsonresp=$ex->getMessage();
               DB::rollBack();
               $data->error   = false;
           }
           $response = $data;
        }
        $responsedata = Defaults::encode($response);
        return $responsedata;

    }
    public function all_user(Request $request)
    {
        $response = new Response();
        if(!$request->token_check){
            $response->error        = Common::error_true;
            $response->errorMessage = trans('messages.token_mismatch');
        }else{
        $rules   = [
            'manager_id'   => 'required|numeric'
        ];
    $validator  = Validator::make($request->all(), $rules);
    if ($validator->fails()) {
     $data                   = $validator->messages();
     $response->error        = Common::error_true;
     $response->errorMessage = $data->first();
    } else {
        $data   = new DataService();
        try{
            $manager_id = $request->manager_id;
            

            $Event_attendance_obj = new Event_attendance();
            $q = $Event_attendance_obj->select("event_attendance.*","users.firstname","users.lastname","users.telephone","users.email")
                ->leftJoin("users","users.id","event_attendance.user_id")
                ->where("event_attendance.manager_id",$request->manager_id);
            if(!empty($request->date))
            {
                $date = str_replace("/","-",$request->date);
                $date = date("Y-m-d 00:00:00",strtotime($date));
                $q->where("today_date",$date);
            }else{
                $date = date("Y-m-d 00:00:00");
                $q->where("today_date",$date);
            }    
            $record = $q->get()->toArray();
            /*$gett = DB::getQueryLog();
            print_r($gett);die;*/
                if(count($record)>0)
                {
                    $x=0;
                    foreach ($record as $key => $value)
                    {

                        $d = strftime("%d %B, %Y",strtotime($value["created_at"]));
                        $t = date("h:i A",strtotime($value["created_at"]));
                        $record[$x]["check_in_time"] = $d.$t;
                        $x++;
                    }
                    $data->error = Common::error_false;
                    $data->errorMessage = trans('messages.sucess');
                    $data->usersDetails = $record;
                }else{
                    $data->error         = Common::error_true;
                    $data->errorMessage  = trans('messages.no_record');
                }
            }catch(QueryException $ex){
            $jsonresp=$ex->getMessage();
            DB::rollBack();
            $data->error   = false;
        }
        
        $response = $data;
    }

        }
        $responsedata = Defaults::encode($response);
        return $responsedata;

    }

    public function getCSVurl(Request $request)
    {
        $response = new Response();
        if(!$request->token_check){
            $response->error        = Common::error_true;
            $response->errorMessage = trans('messages.token_mismatch');
        }else{
        $rules   = [
            'event_id'   => 'required|numeric',
            'user_id' => 'required|numeric',
        ];
        $validator  = Validator::make($request->all(), $rules);
        if ($validator->fails()) {
         $data                   = $validator->messages();
         $response->error        = Common::error_true;
         $response->errorMessage = $data->first();
        } else {
                $data   = new DataService();
                try{
                    $user_id = $request->user_id;
                    $Managers_obj = new Managers();
                    $manager_record = $Managers_obj->select("email")->where("id",$user_id)->get()->toArray();
                    if(count($manager_record)>0)
                    {
                        $email = $manager_record[0]["email"];
                        $Event_attendance_obj = new Event_attendance();
                        $record = $Event_attendance_obj
                            ->where("event_id",$request->event_id)
                            ->count();
                            $url = url("api/import_csv?event_id=").$request->event_id;
                        if($record > 0)
                        {
                            $objDemo = new \stdClass();
                            $objDemo->sender = 'TNT';
                            $objDemo->invoice_file = '';
                            $objDemo->receiver = $record[0]["firstname"]." ".$record[0]["lastname"];
                            $objDemo->from = env( 'MAIL_USERNAME' );
                            $objDemo->subject = trans('messages.Thank You with TNT');
                            $objDemo->message = "forgot_password_message";
                            $objDemo->csv_url = $url;
                            $objDemo->view_file = 'emailtemplate.csv_url_file';
                            Mail::to($email)->send(new DemoEmail($objDemo));

                            $data->error = Common::error_false;
                            $data->errorMessage = trans('messages.import_csv_message');
                        }else{
                            $data->error = Common::error_true;
                            $data->errorMessage = trans('messages.no_record');
                        }
                    }else{

                    }
                               
                    }catch(QueryException $ex){
                    $jsonresp=$ex->getMessage();
                    DB::rollBack();
                    $data->error   = false;
                }
                $response = $data;
            }
        }
        $responsedata = Defaults::encode($response);
        return $responsedata;
    }
    public function import_csv(Request $request)
    {
        $response = new Response();
        $request->token_check = 1;
        if(!$request->token_check){
            $response->error        = Common::error_true;
            $response->errorMessage = trans('messages.token_mismatch');
        }else{
        $rules   = [
            'event_id'   => 'required|numeric'
        ];
    $validator  = Validator::make($request->all(), $rules);
    if ($validator->fails()) {
     $data                   = $validator->messages();
     $response->error        = Common::error_true;
     $response->errorMessage = $data->first();
    } else {
        $data   = new DataService();
        try{
            $Event_attendance_obj = new Event_attendance();
             $record = $Event_attendance_obj->select("event_attendance.id","event_attendance.created_at","events.event_name","users.firstname","users.lastname","users.telephone","users.email")
                ->leftJoin("events","events.id","event_attendance.event_id")
                ->leftJoin("users","users.id","event_attendance.user_id")
                ->where("event_id",$request->event_id)
                ->get()->toArray();
             $filename = "Event_list.csv";
             $fp = fopen('php://output', 'w');

             $array_key = array(trans('messages.Id'),trans('messages.Event name'),trans('messages.First name'),trans('messages.Last name'), trans('messages.Telephone Number'),trans('messages.Email'),trans('messages.check in time'));
             foreach ($array_key as $key => $value) {
                $header[] = $value;
             }

             header('Content-type: application/csv');
             header('Content-Disposition: attachment; filename='.$filename);
             fputcsv($fp, $header);
             foreach($record as $orderValue){

                $d = strftime("%d %B, %Y",strtotime($orderValue["created_at"]));
                        $t = date(" h:i A",strtotime($orderValue["created_at"]));
                        $check_in_time = $d.$t;

                fputcsv($fp,array(
                   $orderValue['id'],
                   $orderValue["event_name"],
                   $orderValue["firstname"],
                   $orderValue["lastname"],
                   $orderValue["telephone"],
                   $orderValue["email"],
                   $check_in_time
                   ));
             }
             exit();
             $data->error = Common::error_false;
                    $data->errorMessage = trans('messages.sucess');
                    
             }catch(QueryException $ex){
            $jsonresp=$ex->getMessage();
            DB::rollBack();
            $data->error   = false;
        }
        
        $response = $data;
    }

        }
        $responsedata = Defaults::encode($response);
        return $responsedata;
          
    }
}
