<?php

namespace App\Http\Requests;

use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Http\Request;
class SpecialistRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules(Request $request)
    {
         
        $hospital_id = $request->session()->get("id");
    return [
            'fullname' => 'required|min:2|regex:/^[\pL\s\-]+$/u',
            'finess_number' => 'required|min:2|regex:/^[\w]+([-_\s]{1}[a-z0-9]+)*$/i',
            'company_name' => 'required|regex:/^[\w]+([-_\s]{1}[a-z0-9]+)*$/i',
            //'category' => 'required',
            //"sub_cat"    => "required|array",
            #'sub_cat.*' => 'required',
            'admin_name' => 'required|regex:/^[\pL\s\-]+$/u',
            'admin_email'=> 'required|email|regex:/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix|unique:hospitalusers,admin_email,'.$hospital_id,
            'admin_telephone'=> 'required|numeric|digits_between:7,15|unique:hospitalusers,admin_telephone,'.$hospital_id,
            
            'address'    => 'required',
            'waiting_time'    => 'required|numeric',
              "image" => "mimes:jpeg,jpg,png,gif"
      ];
    }
}
