<?php
 
namespace App\Mail;
 
use Illuminate\Bus\Queueable;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;
use Illuminate\Contracts\Queue\ShouldQueue;
 
class DemoEmail extends Mailable
{
    use Queueable, SerializesModels;
     
    /**
     * The demo object instance.
     *
     * @var Demo
     */
    public $demo;
 
    /**
     * Create a new message instance.
     *
     * @return void
     */
    public function __construct($demo)
    {
        $this->demo = $demo;
    }
 
    /**
     * Build the message.
     *
     * @return $this
     */
    public function build()
    {
        //print_r($this->demo->from);die;
        if($this->demo->invoice_file){
            return $this->from($this->demo->from)
                    ->subject($this->demo->subject)
                    ->view($this->demo->view_file)->attach($this->demo->invoice_path, [
                        'as' => $this->demo->invoice_file,
                        'mime' => 'application/html',
                    ]);
        }else{
            return $this->from($this->demo->from)
                    ->subject($this->demo->subject)
                    ->view($this->demo->view_file);
        }

        
                    //->text('mails.demo_plain')
                    /*->with(
                      [
                            'testVarOne' => '1',
                            'testVarTwo' => '2',
                      ]) 
                    //http://studentboxafrica.maxcomwebhost.com/public/upload/user/1567497210.jpeg
                      ->attach(public_path('upload/user').'/1567497210.jpeg', [
                              'as' => '1567497210.jpeg',
                              'mime' => 'image/jpeg',
                      ]);*/
    }
}