<?php

use Illuminate\Http\Request;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

Route::middleware('auth:api')->get('/user', function (Request $request) {
    return $request->user();
});

Route::get("getInfo","api\ApiController@getInfo");
Route::post("registration","api\ApiController@registration");
Route::post("login","api\ApiController@login");
Route::post("userForgotPassword","api\ApiController@userForgotPassword");
Route::middleware(["Checkusertoken"])->group(function(){

	Route::post("singleEvents","api\ApiController@singleEvents");
	Route::post("getUserHistory","api\ApiController@getUserHistory");
	Route::post("getProfile","api\ApiController@getProfile");
	Route::post("edituserprofile","api\ApiController@EditUserProfile");
	Route::post("generateQRcode","api\ApiController@generateQRcode");

	Route::middleware(["Checkusertokensecond"])->group(function(){	
		Route::post("homeApi","api\ApiController@homeApi");
		Route::post("uploadGallery","api\ApiController@uploadGallery");
		Route::post("getGallery","api\ApiController@getGallery");
		Route::post("getGalleryAllImageEvent","api\ApiController@getGalleryAllImageEvent");
		Route::post("getGalleryVideo","api\ApiController@getGalleryVideo");
		Route::post("getGalleryAllImageEventVideo","api\ApiController@getGalleryAllImageEventVideo");
		Route::post("updateSettingNoti","api\ApiController@updateSettingNoti");
		
		Route::post("allEvents","api\ApiController@allEvents");
		Route::post("historyAllEvents","api\ApiController@historyAllEvents");
		
		Route::post("historyUserEvents","api\ApiController@historyUserEvents");
		Route::post("clubList","api\ApiController@clubList");
		
		Route::post("allNews","api\ApiController@allNews");
		Route::post("getAlbumName","api\ApiController@getAlbumName");
		Route::post("TodayCurrentEvents","api\ApiController@TodayCurrentEvents");


	});
});


Route::post("managerRegistration","api\ManagerController@managerRegistration");
Route::post("managerLogin","api\ManagerController@login");
Route::post("managerForgotPassword","api\ManagerController@managerForgotPassword");

Route::middleware(["Checkmanagertoken"])->group(function(){
Route::post("managergetProfile","api\ManagerController@managergetProfile");
	Route::post("manageredituserprofile","api\ManagerController@managerEditUserProfile");
Route::post("scanQRcode","api\ManagerController@scanQRcode");
Route::post("all_user","api\ManagerController@all_user");
Route::match(["get","post"],"import_csv","api\ManagerController@import_csv");
Route::match(["get","post"],"getCSVurl","api\ManagerController@getCSVurl");
});
Route::post("TodayallEvents","api\ManagerController@TodayallEvents");