<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
use App\Clubs;
use App\NewsModel;
use App\Banner;
use App\Setting;
use Illuminate\Support\Str;

Route::get('/', function () {
    return view('welcome');
});
Route::middleware(["AllreadyLoginAdmin"])->group(function(){
	Route::view('login',"admin.login",[ "heading" => trans('messages.Admin Login') ]);
	Route::view('admin',"admin.login",[ "heading" => trans('messages.Admin Login') ]);
});
	Route::post('admin/LoginSubmit', "admin\AdminController@LoginSubmit");
	Route::get('admin/logout', "admin\AdminController@logout");
Route::prefix("admin")->group(function(){
	Route::middleware(["AdminCheck"])->group(function(){
		
			Route::get("cudhuegdnbav/{id}/{status}/{callback}/{table}","admin\AdminController@CommonAed");
			Route::get('dashboard',"admin\AdminController@dashboard");
			
			Route::match(["get","post"],"allUser","admin\AdminController@allUser");
			Route::match(["get","post"],"blockedUser","admin\AdminController@blockedUser");
			Route::match(["get","post"],"allManager","admin\AdminController@allManager");

			Route::match(["get"],"updatePoint/{user_id}","admin\AdminController@updatePoint");
			Route::match(["post"],"updatePointSubmit","admin\AdminController@updatePointSubmit");
			Route::match(["get"],"pointSetting","admin\AdminController@pointSetting");
			Route::match(["post"],"pointSettingSubmit","admin\AdminController@pointSettingSubmit");

			Route::match(["get","post"],"blockedManager","admin\AdminController@blockedManager");

			Route::match(["get"],"eventAttendance","admin\AdminController@eventAttendance");

			Route::match(["get"],"getPointlist","admin\AdminController@getPointlist");
			Route::match(["get"],"getPointdetail/{dates}","admin\AdminController@getPointdetail");

			Route::match(["get"],"eventAllUser/{id}","admin\AdminController@eventAllUser");
			Route::match(["get"],"galleryEvent","admin\AdminController@galleryEvent");
			Route::match(["get"],"userGallery/{id}","admin\AdminController@userGallery");
			Route::match(["get"],"allPicture/{id}","admin\AdminController@allPicture");

			Route::post("galleryApprovel","admin\AdminController@galleryApprovel");
			Route::get("galleryPicture/{id}","admin\AdminController@galleryPicture");
			#Route::get("uploadGalleryImage/{event_id}","admin\AdminController@uploadGalleryImage");
			Route::get("uploadGalleryImage","admin\AdminController@uploadGalleryImage");
			Route::post("uploadGallerySubmit","admin\AdminController@uploadGallerySubmit");
			Route::get("getGallery","admin\AdminController@getGallery");

			Route::get("addClub",function(){
				$data["heading"] = trans("messages.addClub");
				return view("admin.addClub")->with(array("data"=>$data));
			});
			
			Route::post("addclubSubmit","admin\AdminController@addclubSubmit");
			Route::get("listClub","admin\AdminController@listClub");
			

			/*Route::get("listClub",function(){
				$data["heading"] = trans("messages.listClub");
				$Clubs = new Clubs();
				$data["record"] = $Clubs->get_record_pagination();
				return view("admin.listClub")->with(array("data"=>$data));
			});*/
			Route::get("editClub/{id}",function($id){
				$data["heading"] = trans("messages.editClub");
				$Clubs = new Clubs();
				$id = Crypt::decryptString($id);
				$data["record"] = $Clubs->get_record_single($id);
				return view("admin.editClub")->with(array("data"=>$data));
			});
			Route::post("editClubSubmit","admin\AdminController@editClubSubmit");
			Route::get("addEvent",function(){
				$Clubs = new Clubs();
				$data["record"] = $Clubs->get_record_all_active();
				$data["heading"] = trans("messages.addEvent");
				return view("admin.addEvent")->with(array("data"=>$data));
			});
			Route::post("addEventSubmit","admin\AdminController@addEventSubmit");
			Route::get("addWatermark","admin\AdminController@addWatermark");
			Route::get("listEvent","admin\AdminController@listEvent");
			Route::get("editEvents/{id}","admin\AdminController@editEvents");
			Route::post("editEventSubmit","admin\AdminController@editEventSubmit");

			/* News CRUD */
				Route::get("listNews",function(){
				$data["heading"] = trans("messages.listNews");
				$newsObj = new NewsModel();
				$data["record"] = $newsObj->get_record_pagination();
				return view("admin.listNews")->with(array("data"=>$data));
			});

			Route::get("addNews",function(){
				$data["heading"] = trans("messages.addNews");
				return view("admin.addNews")->with(array("data"=>$data));
			});
					
			Route::post("addNewsSubmit","admin\AdminController@addNewsSubmit");
					
			Route::get("editNews/{id}",function($id){
				$data["heading"] = trans("messages.editNews");
				$newsObj = new NewsModel();
				$id = Crypt::decryptString($id);
				$data["record"] = $newsObj->get_record_single(array('id'=>$id));
				return view("admin.editNews")->with(array("data"=>$data));
			});

			Route::post("editNewsSubmit","admin\AdminController@editNewsSubmit");
			

			Route::get("delNews/{id}","admin\AdminController@delNews");
			/************/
		
		Route::get("listBanner",function(){
			$data["heading"] = trans("messages.listBanner");
			$banner_obj = new Banner();
			$data["record"] = $banner_obj->get_record_pagination();
			return view("admin.listBanner")->with(array("data"=>$data));
		});

		Route::get("addBanner",function(){
			$data["heading"] = trans("messages.addBanner");
			return view("admin.addBanner")->with(array("data"=>$data));
		});
				
		Route::post("addBannerSubmit","admin\BannerController@addBannerSubmit");
		Route::get("updateBanner/{id}","admin\BannerController@updateBanner");		
		Route::get("editBanner/{id}",function($id){
			$data["heading"] = trans("messages.editBanner");
			$banner_obj = new Banner();
			$id = Crypt::decryptString($id);
			$data["record"] = $banner_obj->get_record_single(array('id'=>$id));
			return view("admin.editBanner")->with(array("data"=>$data));
		});

		Route::post("editBannerSubmit","admin\BannerController@editBannerSubmit");
		Route::post("editHomeMusicSubmit","admin\AdminController@editHomeMusicSubmit");
		Route::get("editHomeMusic",function(){
			$data["heading"] = trans("messages.Home Music");
			$Setting_obj = new Setting();
			$data["record"] = $ringtone_record = $Setting_obj->where("meta_key","homeringtone")->first();
			#print_r($ringtone_record->id);die;
			///$id = $ringtone_record->id;
			$data["id"] = $id = $ringtone_record->id;
			return view("admin.editHomeMusic")->with(array("data"=>$data));
		});
		Route::get("deleteMusic","admin\AdminController@deleteMusic");
		Route::get("info","admin\AdminController@info");
		Route::post("infoSubmit","admin\AdminController@infoSubmit");

		Route::match(["get"],"deletePush/{id}","admin\AdminController@deletePush");
		Route::match(["get"],"listPush","admin\AdminController@listPush");
		Route::match(["get"],"sendPush","admin\AdminController@sendPush");
			Route::match(["post"],"sendPushSubmit","admin\AdminController@sendPushSubmit");
	});
});